unit AmigaDOS;

INTERFACE
uses Exec, Timer, Utility;


type
	BPTR = longint;
	BSTR = longint;
	pDateStamp = ^tDateStamp;
	tDateStamp = record
		ds_Days: longint;
		ds_Minute: longint;
		ds_Tick: longint;
		end;

	pRootNode = ^tRootNode;
	tRootNode = record
		rn_TaskArray: BPTR;
		rn_ConsoleSegment: BPTR;
		rn_Time: tDateStamp;
		rn_RestartSeg: longint;
		rn_Info: BPTR;
		rn_FileHandlerSegment: BPTR;
		rn_CliList: tMinList;
		rn_BootProc: pMsgPort;
		rn_ShellSegment: BPTR;
		rn_Flags: longint;
		end;

	pDosPacket = ^tDosPacket;
	tDosPacket = record
		dp_Link: pMessage;
		dp_Port: pMsgPort;
		case integer of
		0: (
		dp_Action: longint;
		dp_Status: longint;
		dp_Status2: longint;
		dp_BufAddr: longint;
		);
		1: (
		dp_Type: longint;
		dp_Res1: longint;
		dp_Res2: longint;
		dp_Arg1: longint;
		dp_Arg2: longint;
		dp_Arg3: longint;
		dp_Arg4: longint;
		dp_Arg5: longint;
		dp_Arg6: longint;
		dp_Arg7: longint;
		);
		end;

	pStandardPacket = ^tStandardPacket;
	tStandardPacket = record
		sp_Msg: tMessage;
		sp_Pkt: tDosPacket;
		end;

	pErrorString = ^tErrorString;
	pDosLibrary = ^tDosLibrary;
	tDosLibrary = record
		dl_lib: tLibrary;
		dl_Root: pRootNode;
		dl_GV: pointer;
		dl_A2: longint;
		dl_A5: longint;
		dl_A6: longint;
		dl_Errors: pErrorString;
		dl_TimeReq: ptimerequest;
		dl_UtilityBase: pLibrary;
		dl_IntuitionBase: pLibrary;
		end;

	pAssignList = ^tAssignList;
	tAssignList = record
		al_Next: pAssignList;
		al_Lock: BPTR;
		end;

	pSegment = ^tSegment;
	tSegment = record
		seg_Next: BPTR;
		seg_UC: longint;
		seg_Seg: BPTR;
		seg_Name: array [0..3] of byte;
		end;

	pProcess = ^tProcess;
	tProcess = record
		pr_Task: tTask;
		pr_MsgPort: tMsgPort;
		pr_Pad: integer;
		pr_SegList: BPTR;
		pr_StackSize: longint;
		pr_GlobVec: pointer;
		pr_TaskNum: longint;
		pr_StackBase: BPTR;
		pr_Result2: longint;
		pr_CurrentDir: BPTR;
		pr_CIS: BPTR;
		pr_COS: BPTR;
		pr_ConsoleTask: pointer;
		pr_FileSystemTask: pointer;
		pr_CLI: BPTR;
		pr_ReturnAddr: pointer;
		pr_PktWait: pointer;
		pr_WindowPtr: pointer;
		pr_HomeDir: BPTR;
		pr_Flags: longint;
		pr_ExitCode: pointer;
		pr_ExitData: longint;
		pr_Arguments: pbyte;
		pr_LocalVars: tMinList;
		pr_ShellPrivate: long;
		pr_CES: BPTR;
		end;

	pNotifyRequest = ^tNotifyRequest;
	pNotifyMessage = ^tNotifyMessage;
	tNotifyMessage = record
		nm_ExecMessage: tMessage;
		nm_Class: long;
		nm_Code: word;
		nm_NReq: pNotifyRequest;
		nm_DoNotTouch: long;
		nm_DoNotTouch2: long;
		end;

	pFileSysStartupMsg = ^tFileSysStartupMsg;
	tFileSysStartupMsg = record
		fssm_Unit: long;
		fssm_Device: BSTR;
		fssm_Environ: BPTR;
		fssm_Flags: long;
		end;

	pExAllData = ^tExAllData;
	tExAllData = record
		ed_Next: pExAllData;
		ed_Name: pbyte;
		ed_Type: longint;
		ed_Size: long;
		ed_Prot: long;
		ed_Days: long;
		ed_Mins: long;
		ed_Ticks: long;
		ed_Comment: pbyte;
		end;

	pCSource = ^tCSource;
	tCSource = record
		CS_Buffer: pbyte;
		CS_Length: longint;
		CS_CurChr: longint;
		end;

	pRDArgs = ^tRDArgs;
	tRDArgs = record
		RDA_Source: tCSource;
		RDA_DAList: longint;
		RDA_Buffer: pbyte;
		RDA_BufSiz: longint;
		RDA_ExtHelp: pbyte;
		RDA_Flags: longint;
		end;

	tErrorString = record
		estr_Nums: plongint;
		estr_Strings: pbyte;
		end;

	pAChain = ^tAChain;
	pFileInfoBlock = ^tFileInfoBlock;
	tFileInfoBlock = record
		fib_DiskKey: longint;
		fib_DirEntryType: longint;
		fib_FileName: array [0..107] of byte;
		fib_Protection: longint;
		fib_EntryType: longint;
		fib_Size: longint;
		fib_NumBlocks: longint;
		fib_Date: tDateStamp;
		fib_Comment: array [0..79] of byte;
		fib_Reserved: array [0..35] of byte;
		end;

	tAChain = record
		an_Child: pAChain;
		an_Parent: pAChain;
		an_Lock: BPTR;
		an_Info: tFileInfoBlock;
		an_Flags: shortint;
		an_String: array [0..0] of byte;
		end;

	pFileHandle = ^tFileHandle;
	tFileHandle = record
		fh_Link: pMessage;
		fh_Port: pMsgPort;
		fh_Type: pMsgPort;
		fh_Buf: longint;
		fh_Pos: longint;
		fh_End: longint;
		fh_Func1: longint;
		fh_Func2: longint;
		fh_Func3: longint;
		fh_Arg1: longint;
		fh_Arg2: longint;
		end;

	tNotifyRequest = record
		nr_Name: pbyte;
		nr_FullName: pbyte;
		nr_UserData: long;
		nr_Flags: long;
		case integer of
		0: (
		nr_Msg: record
		nr_Port: pMsgPort;
		end;
		);
		1: (
		nr_Signal: record
		nr_Task: pTask;
		nr_SignalNum: byte;
		nr_pad: array [0..2] of byte;
		end;
		nr_Reserved: array [0..3] of long;
		nr_MsgCount: long;
		nr_Handler: pMsgPort;
		);
		end;

	pInfoData = ^tInfoData;
	tInfoData = record
		id_NumSoftErrors: longint;
		id_UnitNumber: longint;
		id_DiskState: longint;
		id_NumBlocks: longint;
		id_NumBlocksUsed: longint;
		id_BytesPerBlock: longint;
		id_DiskType: longint;
		id_VolumeNode: BPTR;
		id_InUse: longint;
		end;

	pFileLock = ^tFileLock;
	tFileLock = record
		fl_Link: BPTR;
		fl_Key: longint;
		fl_Access: longint;
		fl_Task: pMsgPort;
		fl_Volume: BPTR;
		end;

	pDeviceNode = ^tDeviceNode;
	tDeviceNode = record
		dn_Next: BPTR;
		dn_Type: long;
		dn_Task: pMsgPort;
		dn_Lock: BPTR;
		dn_Handler: BSTR;
		dn_StackSize: long;
		dn_Priority: longint;
		dn_Startup: BPTR;
		dn_SegList: BPTR;
		dn_GlobalVec: BPTR;
		dn_Name: BSTR;
		end;

	pDateTime = ^tDateTime;
	tDateTime = record
		dat_Stamp: tDateStamp;
		dat_Format: byte;
		dat_Flags: byte;
		dat_StrDay: pbyte;
		dat_StrDate: pbyte;
		dat_StrTime: pbyte;
		end;

	pDevInfo = ^tDevInfo;
	tDevInfo = record
		dvi_Next: BPTR;
		dvi_Type: longint;
		dvi_Task: pointer;
		dvi_Lock: BPTR;
		dvi_Handler: BSTR;
		dvi_StackSize: longint;
		dvi_Priority: longint;
		dvi_Startup: longint;
		dvi_SegList: BPTR;
		dvi_GlobVec: BPTR;
		dvi_Name: BSTR;
		end;

	pLocalVar = ^tLocalVar;
	tLocalVar = record
		lv_Node: tNode;
		lv_Flags: word;
		lv_Value: pbyte;
		lv_Len: long;
		end;

	pDosInfo = ^tDosInfo;
	tDosInfo = record
		case integer of
		0: (
		di_ResList: BPTR;
		);
		1: (
		di_McName: BPTR;
		di_DevInfo: BPTR;
		di_Devices: BPTR;
		di_Handlers: BPTR;
		di_NetHand: pointer;
		di_DevLock: tSignalSemaphore;
		di_EntryLock: tSignalSemaphore;
		di_DeleteLock: tSignalSemaphore;
		);
		end;

	pDosEnvec = ^tDosEnvec;
	tDosEnvec = record
		de_TableSize: long;
		de_SizeBlock: long;
		de_SecOrg: long;
		de_Surfaces: long;
		de_SectorPerBlock: long;
		de_BlocksPerTrack: long;
		de_Reserved: long;
		de_PreAlloc: long;
		de_Interleave: long;
		de_LowCyl: long;
		de_HighCyl: long;
		de_NumBuffers: long;
		de_BufMemType: long;
		de_MaxTransfer: long;
		de_Mask: long;
		de_BootPri: longint;
		de_DosType: long;
		de_Baud: long;
		de_Control: long;
		de_BootBlocks: long;
		end;

	pDosList = ^tDosList;
	pDevProc = ^tDevProc;
	tDevProc = record
		dvp_Port: pMsgPort;
		dvp_Lock: BPTR;
		dvp_Flags: long;
		dvp_DevNode: pDosList;
		end;

	ppMsgPort = ^pMsgPort;
	pCliProcList = ^tCliProcList;
	tCliProcList = record
		cpl_Node: tMinNode;
		cpl_First: longint;
		cpl_Array: ppMsgPort;
		end;

	pCommandLineInterface = ^tCommandLineInterface;
	tCommandLineInterface = record
		cli_Result2: longint;
		cli_SetName: BSTR;
		cli_CommandDir: BPTR;
		cli_ReturnCode: longint;
		cli_CommandName: BSTR;
		cli_FailLevel: longint;
		cli_Prompt: BSTR;
		cli_StandardInput: BPTR;
		cli_CurrentInput: BPTR;
		cli_CommandFile: BSTR;
		cli_Interactive: longint;
		cli_Background: longint;
		cli_CurrentOutput: BPTR;
		cli_DefaultStack: longint;
		cli_StandardOutput: BPTR;
		cli_Module: BPTR;
		end;

	pAnchorPath = ^tAnchorPath;
	tAnchorPath = record
		case integer of
		0: (
		ap_First: pAChain;
		ap_Last: pAChain;
		);
		1: (
		ap_Base: pAChain;
		ap_Current: pAChain;
		ap_BreakBits: longint;
		ap_FoundBreak: longint;
		ap_Flags: shortint;
		ap_Reserved: shortint;
		ap_Strlen: integer;
		ap_Info: tFileInfoBlock;
		ap_Buf: array [0..0] of byte;
		);
		end;

	pRecordLock = ^tRecordLock;
	tRecordLock = record
		rec_FH: BPTR;
		rec_Offset: long;
		rec_Length: long;
		rec_Mode: long;
		end;

	pDeviceList = ^tDeviceList;
	tDeviceList = record
		dl_Next: BPTR;
		dl_Type: longint;
		dl_Task: pMsgPort;
		dl_Lock: BPTR;
		dl_VolumeDate: tDateStamp;
		dl_LockList: BPTR;
		dl_DiskType: longint;
		dl_unused: longint;
		dl_Name: BSTR;
		end;

	pExAllControl = ^tExAllControl;
	tExAllControl = record
		eac_Entries: long;
		eac_LastKey: long;
		eac_MatchString: pbyte;
		eac_MatchFunc: pHook;
		end;

	tDosList = record
		dol_Next: BPTR;
		dol_Type: longint;
		dol_Task: pMsgPort;
		dol_Lock: BPTR;
		case integer of
		0: (
		dol_handler: record
		dol_Handler: BSTR;
		dol_StackSize: longint;
		dol_Priority: longint;
		dol_Startup: long;
		dol_SegList: BPTR;
		dol_GlobVec: BPTR;
		end;
		);
		1: (
		dol_volume: record
		dol_VolumeDate: tDateStamp;
		dol_LockList: BPTR;
		dol_DiskType: longint;
		end;
		);
		2: (
		dol_assign: record
		dol_AssignName: pbyte;
		dol_List: pAssignList;
		end;
		dol_Name: BSTR;
		);
		end;



const
	ACTION_LOCATE_OBJECT = 8;
	ACTION_RENAME_OBJECT = $11;
	RNB_PRIVATE1 = 1;
	LDB_ENTRY = 5;
	MODE_NEWFILE = $3EE;
	FIBF_DELETE = 1;
	NP_Output = $800003ED;
	DE_SIZEBLOCK = 1;
	NRF_NOTIFY_INITIAL = $10;
	DDF_Single = $10;
	APB_FollowHLinks = 7;
	P_ANY = $80;
	ACTION_SET_PROTECT = $15;
	CMD_INTERNAL = $FFFFFFFE;
	SIGBREAKB_CTRL_C = $C;
	RNF_PRIVATE1 = 2;
	LDF_ENTRY = $20;
	ACCESS_READ = $FFFFFFFE;
	ID_KICKSTART_DISK = $FB49434B;
	SIGBREAKB_CTRL_D = $D;
	DDB_PatternBit = 0;
	PRB_FREEARGS = 5;
	RDAB_NOPROMPT = 2;
	ERROR_LINE_TOO_LONG = $78;
	ERROR_OBJECT_TOO_LARGE = $CF;
	SIGBREAKB_CTRL_E = $E;
	CHANGE_LOCK = 0;
	LINK_SOFT = 1;
	P_REPBEG = $89;
	DLT_DIRECTORY = 1;
	SIGBREAKB_CTRL_F = $F;
	DTB_SUBST = 0;
	APF_FollowHLinks = $80;
	EXT_REF8 = $84;
	ERROR_NO_FREE_STORE = $67;
	ERROR_DIR_NOT_FOUND = $CC;
	SIGBREAKF_CTRL_C = $1000;
	NP_Priority = $800003F5;
	SIGBREAKF_CTRL_D = $2000;
	DDF_PatternBit = 1;
	PRF_FREEARGS = $20;
	RDAF_NOPROMPT = 4;
	ID_MSDOS_DISK = $FD534400;
	SIGBREAKF_CTRL_E = $4000;
	APB_NOMEMERR = 4;
	DDB_Completed = 2;
	ACTION_READ_LINK = $400;
	NRB_WAIT_REPLY = 3;
	ERROR_BAD_STREAM_NAME = $CE;
	SIGBREAKF_CTRL_F = $8000;
	DTF_SUBST = 1;
	ACTION_GET_BLOCK = 2;
	ACTION_FREE_LOCK = $F;
	DLT_LATE = 3;
	DE_BAUD = $11;
	MAX_MULTIARGS = $80;
	P_NOT = $85;
	ACTION_MAKE_LINK = $3FD;
	LDB_DEVICES = 2;
	ID_NO_DISK_PRESENT = $FFFFFFFF;
	ERROR_UNMATCHED_QUOTES = $77;
	ED_DATE = 5;
	NR_HANDLER_FLAGS = $FFFF0000;
	LV_ALIAS = 1;
	DOSNAME = 'dos.library';
	ERROR_INVALID_RESIDENT_LIBRARY = $7A;
	APF_NOMEMERR = $10;
	DDF_Completed = 4;
	ACTION_FINDOUTPUT = $3EE;
	HUNK_END = $3F2;
	HUNK_LIB = $3FA;
	NRF_WAIT_REPLY = 8;
	ACCESS_WRITE = $FFFFFFFF;
	P_REPEND = $8A;
	ACTION_SAME_LOCK = $28;
	ERROR_TOO_MANY_ARGS = $76;
	LDF_DEVICES = 4;
	ED_NAME = 1;
	BYTESPERLONG = 4;
	ITEM_UNQUOTED = 1;
	ACTION_READ = $52;
	ACTION_TIMER = $1E;
	RUN_SYSTEM = $FFFFFFFE;
	OFFSET_BEGINING = $FFFFFFFF;
	ERROR_LOCK_TIMEOUT = $F2;
	ACTION_EVENT = 6;
	ACTION_FLUSH = $1B;
	ACTION_FINDINPUT = $3ED;
	HUNK_UNIT = $3E7;
	ERROR_OBJECT_WRONG_TYPE = $D4;
	P_SINGLE = $81;
	ACTION_WAIT_CHAR = $14;
	NRB_SEND_MESSAGE = 0;
	ID_INTER_FFS_DISK = $44F5303;
	PRB_FREECLI = 2;
	LDF_ALL = $1C;
	REPORT_STREAM = 0;
	DE_NUMHEADS = 3;
	ERROR_OBJECT_NOT_FOUND = $CD;
	RETURN_OK = 0;
	HUNK_HEADER = $3F3;
	SHARED_LOCK = $FFFFFFFE;
	ACTION_DISK_INFO = $19;
	ADO_Dummy = $800007D0;
	NRF_SEND_MESSAGE = 1;
	ERROR_REQUIRED_ARG_MISSING = $74;
	ERROR_UNLOCK_ERROR = $F3;
	ITEM_NOTHING = 0;
	ACTION_PARENT_FH = $407;
	NP_HomeDir = $800003F8;
	ADO_FH_Mode = $800007D1;
	ADO_PromptLen = $800007D5;
	P_NOTEND = $86;
	PRF_FREECLI = 4;
	DE_BLKSPERTRACK = 5;
	HUNK_RELOC8 = $3EE;
	P_ORSTART = $82;
	ACTION_WRITE = $57;
	DE_MASK = $E;
	ID_INTER_DOS_DISK = $44F5302;
	ERROR_BAD_NUMBER = $73;
	NP_Cli = $800003FA;
	NP_CommandName = $800003FC;
	ERROR_NOT_IMPLEMENTED = $EC;
	DOS_FIB = 2;
	EXAMINE_BIT = 2;
	ACTION_SEEK = $3F0;
	DE_RESERVEDBLKS = 6;
	ERROR_NO_DISK = $E2;
	RNB_WILDSTAR = $18;
	REPORT_INSERT = 4;
	GVB_DONT_NULL_TERM = $B;
	FIBB_SCRIPT = 6;
	ERROR_FILE_NOT_OBJECT = $79;
	DOS_FILEHANDLE = 0;
	APB_DIDDIR = 3;
	HUNK_BSS = $3EB;
	NP_ExitData = $80000401;
	DOS_EXALLCONTROL = 1;
	NP_Name = $800003F4;
	NP_ExitCode = $80000400;
	BITSPERLONG = $20;
	ACTION_INFO = $1A;
	LDB_ASSIGNS = 4;
	LDB_DELETE = 6;
	REPORT_VOLUME = 3;
	NOTIFY_CLASS = $40000000;
	RNF_WILDSTAR = $1000000;
	NP_Synchronous = $800003FF;
	GVF_DONT_NULL_TERM = $800;
	TICKS_PER_SECOND = $32;
	FIBF_SCRIPT = $40;
	ERROR_DISK_WRITE_PROTECTED = $D6;
	ERROR_READ_PROTECTED = $E0;
	APF_DIDDIR = 8;
	DOS_CLI = 4;
	BITSPERBYTE = 8;
	ERROR_TASK_TABLE_FULL = $69;
	LDF_ASSIGNS = $10;
	LDF_DELETE = $40;
	ERROR_BUFFER_OVERFLOW = $12F;
	ERROR_BREAK = $130;
	ACTION_CHANGE_MODE = $404;
	EXT_DEF = 1;
	ERROR_IS_SOFT_LINK = $E9;
	ACTION_CURRENT_VOLUME = 7;
	EXT_DEXT32 = $85;
	ID_UNREADABLE_DISK = $2414400;
	DVPB_ASSIGN = 1;
	HUNK_EXT = $3EF;
	ID_NOT_REALLY_DOS = $FE444F53;
	LOCK_SAME_VOLUME = 1;
	PRB_FREESEGLIST = 0;
	PRB_FREECURRDIR = 1;
	EXT_DEXT16 = $86;
	APB_ITSWILD = 1;
	HUNK_OVERLAY = $3F5;
	ED_SIZE = 3;
	NOTIFY_CODE = $1234;
	P_CLASS = $88;
	ACTION_DIE = 5;
	ACTION_DISK_CHANGE = $21;
	DVPF_ASSIGN = 2;
	ST_LINKFILE = $FFFFFFFC;
	ST_PIPEFILE = $FFFFFFFB;
	NP_Path = $800003FB;
	DOSTRUE = $FFFFFFFF;
	ID_FFS_DISK = $44F5301;
	ERROR_WRITE_PROTECTED = $DF;
	LOCK_DIFFERENT = $FFFFFFFF;
	PRF_FREESEGLIST = 1;
	PRF_FREECURRDIR = 2;
	ACTION_DISK_TYPE = $20;
	ST_FILE = $FFFFFFFD;
	EXT_SYMB = 0;
	EXT_ABS = 2;
	REC_SHARED = 2;
	ERROR_ACTION_NOT_KNOWN = $D1;
	ERROR_COMMENT_TOO_BIG = $DC;
	APF_ITSWILD = 2;
	P_OREND = $84;
	COMPLEX_BIT = 1;
	NP_NotifyOnDeath = $800003FE;
	ACTION_SET_DATE = $22;
	DVPB_UNLOCK = 0;
	ABORT_DISK_ERROR = $128;
	FIBB_READ = 3;
	ERROR_OBJECT_LINKED = $EA;
	ERROR_NOT_EXECUTABLE = $131;
	DLT_DEVICE = 0;
	P_ORNEXT = $83;
	ACTION_END = $3EF;
	HUNK_DREL8 = $3F9;
	ED_TYPE = 2;
	NRB_SEND_SIGNAL = 1;
	ERROR_LOCK_COLLISION = $F1;
	APB_DOWILD = 0;
	ACTION_INHIBIT = $1F;
	ACTION_IS_FILESYSTEM = $403;
	RETURN_FAIL = $14;
	DVPF_UNLOCK = 1;
	FIBF_READ = 8;
	ID_DOS_DISK = $44F5300;
	LDB_VOLUMES = 3;
	EXT_REF32 = $81;
	DE_UPPERCYL = $A;
	CHANGE_FH = 1;
	NRF_SEND_SIGNAL = 2;
	APF_DOWILD = 1;
	DLT_PRIVATE = $FFFFFFFF;
	EXT_REF16 = $83;
	REC_EXCLUSIVE_IMMED = 1;
	ERROR_DISK_NOT_VALIDATED = $D5;
	ACTION_SET_FILE_SIZE = $3FE;
	DLT_NONBINDING = 4;
	HUNK_BREAK = $3F6;
	SYS_Asynch = $80000023;
	NP_StackSize = $800003F3;
	RDAB_STDIN = 0;
	ITEM_QUOTED = 2;
	ACTION_REMOVE_NOTIFY = $1002;
	LDF_VOLUMES = 8;
	ED_COMMENT = 6;
	MODE_READWRITE = $3EC;
	ERROR_INVALID_COMPONENT_NAME = $D2;
	DDB_AllBit = 3;
	HUNK_DEBUG = $3F1;
	SYS_UserShell = $80000024;
	NP_FreeSeglist = $800003EA;
	GVB_GLOBAL_ONLY = 8;
	OFFSET_END = 1;
	FIBB_WRITE = 2;
	FORMAT_CDN = 3;
	MININT = $80000000;
	ACTION_EXAMINE_ALL = $409;
	DE_PREFAC = 7;
	RDAF_STDIN = 1;
	RETURN_ERROR = $A;
	ACTION_EXAMINE_NEXT = $18;
	ACTION_FREE_RECORD = $7D9;
	REPORT_LOCK = 2;
	MAXINT = $7FFFFFFF;
	ERROR_NO_DEFAULT_DIR = $C9;
	DDF_AllBit = 8;
	ACTION_NIL = 0;
	ACTION_WRITE_PROTECT = $3FF;
	RUN_SYSTEM_ASYNCH = $FFFFFFFD;
	ADO_CommFileLen = $800007D4;
	GVF_GLOBAL_ONLY = $100;
	FIBF_WRITE = 4;
	ERROR_SEEK_ERROR = $DB;
	ACTION_RENAME_DISK = 9;
	ADO_CommNameLen = $800007D3;
	APB_DirChanged = 6;
	ACTION_COPY_DIR = $13;
	RUN_EXECUTE = $FFFFFFFF;
	ACTION_SCREEN_MODE = $3E2;
	ACTION_FH_FROM_LOCK = $402;
	ERROR_NO_MORE_ENTRIES = $E8;
	EXT_RES = 3;
	NP_CloseError = $800003F1;
	DE_MAXTRANSFER = $D;
	ID_VALIDATING = $51;
	SYS_Dummy = $80000020;
	NP_ConsoleTask = $800003F6;
	NP_CopyVars = $800003F9;
	ITEM_EQUAL = $FFFFFFFE;
	APF_DirChanged = $40;
	ACTION_LOCK_RECORD = $7D8;
	CMD_DISABLED = $FFFFFC19;
	HUNK_SYMBOL = $3F0;
	NP_CurrentDir = $800003F2;
	NP_Error = $800003F0;
	DE_BOOTPRI = $F;
	NRB_MAGIC = $1F;
	LVB_IGNORE = 7;
	DOS_RDARGS = 5;
	ACTION_FINDUPDATE = $3EC;
	APB_DODIR = 2;
	REPORT_TASK = 1;
	SYS_Input = $80000021;
	NP_Dummy = $800003E8;
	DE_CONTROL = $12;
	ACTION_MORE_CACHE = $12;
	HUNK_RELOC32 = $3EC;
	NP_CloseInput = $800003EE;
	ST_SOFTLINK = 3;
	NRF_MAGIC = $80000000;
	LVF_IGNORE = $80;
	ERROR_RENAME_ACROSS_DEVICES = $D7;
	ERROR_TOO_MANY_LEVELS = $D9;
	HUNK_RELOC16 = $3ED;
	ADO_DirLen = $800007D2;
	DE_SECSPERBLK = 4;
	ERROR_BAD_TEMPLATE = $72;
	ERROR_DEVICE_NOT_MOUNTED = $DA;
	APF_DODIR = 4;
	HUNK_INDEX = $3FB;
	NP_Input = $800003EC;
	DE_INTERLEAVE = 8;
	FORMAT_DOS = 0;
	FORMAT_MAX = 3;
	SYS_CustomShell = $80000025;
	NP_Seglist = $800003E9;
	FIBB_ARCHIVE = 4;
	NP_Entry = $800003EB;
	DE_SECORG = 2;
	DE_DOSTYPE = $10;
	DE_BOOTBLOCKS = $13;
	EXCLUSIVE_LOCK = $FFFFFFFF;
	LINK_HARD = 0;
	FORMAT_USA = 2;
	APB_DODOT = 5;
	ERROR_DISK_FULL = $DD;
	RETURN_WARN = 5;
	LOCK_SAME_HANDLER = 1;
	ACTION_EXAMINE_OBJECT = $17;
	FIBB_PURE = 5;
	FIBF_ARCHIVE = $10;
	LOCK_SAME = 0;
	FORMAT_INT = 1;
	ST_LINKDIR = 4;
	DTB_FUTURE = 1;
	ST_ROOT = 1;
	HUNK_DATA = $3EA;
	ID_VALIDATED = $52;
	APF_DODOT = $20;
	DDB_ExaminedBit = 1;
	HUNK_CODE = $3E9;
	ERROR_KEY_NEEDS_ARG = $75;
	ERROR_BAD_HUNK = $EB;
	P_NOTCLASS = $87;
	PRB_CLOSEOUTPUT = 4;
	ACTION_CREATE_DIR = $16;
	FIBF_PURE = $20;
	ERROR_RECORD_NOT_LOCKED = $F0;
	ACTION_SET_MAP = 4;
	LDB_READ = 0;
	NP_WindowPtr = $800003F7;
	ERROR_DELETE_PROTECTED = $DE;
	ITEM_ERROR = $FFFFFFFF;
	DTF_FUTURE = 2;
	ACTION_EXAMINE_FH = $40A;
	CMD_SYSTEM = $FFFFFFFF;
	DDF_ExaminedBit = 2;
	EXT_COMMON = $82;
	LV_VAR = 0;
	OFFSET_CURRENT = 0;
	ERROR_INVALID_LOCK = $D3;
	PRB_CLOSEINPUT = 3;
	PRF_CLOSEOUTPUT = $10;
	ACTION_READ_RETURN = $3E9;
	ABORT_BUSY = $120;
	DOSFALSE = 0;
	DLT_VOLUME = 2;
	LDF_READ = 1;
	HUNK_NAME = $3E8;
	DE_NUMBUFFERS = $B;
	RDAB_NOALLOC = 1;
	GVB_LOCAL_ONLY = 9;
	ERROR_OBJECT_EXISTS = $CB;
	ACTION_FORMAT = $3FC;
	DE_MEMBUFTYPE = $C;
	DE_BUFMEMTYPE = $C;
	GVB_BINARY_VAR = $A;
	ACTION_SET_COMMENT = $1C;
	ACTION_PARENT = $1D;
	ACTION_CHANGE_SIGNAL = $3E3;
	MODE_OLDFILE = $3ED;
	PRF_CLOSEINPUT = 8;
	ERROR_OBJECT_IN_USE = $CA;
	DOS_STDPKT = 3;
	NP_Arguments = $800003FD;
	RDAF_NOALLOC = 2;
	GVF_LOCAL_ONLY = $200;
	FIBB_EXECUTE = 1;
	ERROR_DIRECTORY_NOT_EMPTY = $D8;
	GVF_BINARY_VAR = $400;
	ERROR_NOT_A_DOS_DISK = $E1;
	ACTION_STARTUP = 0;
	LDB_WRITE = 1;
	HUNK_DREL32 = $3F7;
	ID_WRITE_PROTECTED = $50;
	EXT_DEXT8 = $87;
	OFFSET_BEGINNING = $FFFFFFFF;
	ACTION_DELETE_OBJECT = $10;
	HUNK_DREL16 = $3F8;
	FIBF_EXECUTE = 2;
	LEN_DATSTRING = $10;
	P_STOP = $8B;
	ACTION_WRITE_RETURN = $3EA;
	ST_USERDIR = 2;
	MAX_TEMPLATE_ITEMS = $64;
	FIBB_DELETE = 0;
	ACTION_COPY_DIR_FH = $406;
	ACTION_ADD_NOTIFY = $1001;
	LDF_WRITE = 2;
	SYS_Output = $80000022;
	ED_PROTECTION = 4;
	NRB_NOTIFY_INITIAL = 4;
	FAULT_MAX = $52;
	DDB_Single = 4;
	NP_CloseOutput = $800003EF;
	DE_TABLESIZE = 0;
	ACTION_SERIALIZE_DISK = $1068;
	DE_LOWCYL = 9;
	REC_EXCLUSIVE = 0;
	REC_SHARED_IMMED = 3;


function Open
		(name: STRPTR;
		accessMode: longint): BPTR;

function Close_ (file_: BPTR): boolean;
function Read_
		(file_: BPTR;
		buffer: pointer;
		length: longint): longint;

function Write_
		(file_: BPTR;
		buffer: pointer;
		length: longint): longint;

function Input_: BPTR;
function Output_: BPTR;
function Seek_
		(file_: BPTR;
		position: longint;
		offset: longint): longint;

function DeleteFile (name: STRPTR): boolean;
function Rename_
		(oldName: STRPTR;
		newName: STRPTR): boolean;

function Lock
		(name: STRPTR;
		type_: longint): BPTR;

procedure UnLock (lock: BPTR);
function DupLock (lock: BPTR): BPTR;
function Examine
		(lock: BPTR;
		fileInfoBlock: pFileInfoBlock): boolean;

function ExNext
		(lock: BPTR;
		fileInfoBlock: pFileInfoBlock): boolean;

function Info
		(lock: BPTR;
		parameterBlock: pInfoData): boolean;

function CreateDir (name: STRPTR): BPTR;
function CurrentDir (lock: BPTR): BPTR;
function IoErr: longint;
function CreateProc
		(name: STRPTR;
		pri: longint;
		segList: BPTR;
		stackSize: longint): pMsgPort;

procedure Exit_ (returnCode: longint);
function LoadSeg (name: STRPTR): BPTR;
function UnLoadSeg (seglist: BPTR): boolean;
function DeviceProc (name: STRPTR): pMsgPort;
function SetComment
		(name: STRPTR;
		comment: STRPTR): boolean;

function SetProtection
		(name: STRPTR;
		protect: longint): boolean;

function DateStamp (date: pDateStamp): pDateStamp;
procedure Delay_ (timeout: long);
function WaitForChar
		(file_: BPTR;
		timeout: longint): boolean;

function ParentDir (lock: BPTR): BPTR;
function IsInteractive (file_: BPTR): boolean;
function Execute
		(string_: STRPTR;
		file_: BPTR;
		file2: BPTR): boolean;

function AllocDosObject
		(type_: long;
		tags: pTagItem): pointer;

procedure FreeDosObject
		(type_: long;
		ptr: pointer);

function DoPkt
		(port: pMsgPort;
		action: longint;
		arg1: longint;
		arg2: longint;
		arg3: longint;
		arg4: longint;
		arg5: longint): longint;

procedure SendPkt
		(dp: pDosPacket;
		port: pMsgPort;
		replyport: pMsgPort);

function WaitPkt: pDosPacket;
procedure ReplyPkt
		(dp: pDosPacket;
		res1: longint;
		res2: longint);

procedure AbortPkt
		(port: pMsgPort;
		pkt: pDosPacket);

function LockRecord
		(fh: BPTR;
		offset: long;
		length: long;
		mode: long;
		timeout: long): long;

function LockRecords
		(recArray: pRecordLock;
		timeout: long): boolean;

function UnLockRecord
		(fh: BPTR;
		offset: long;
		length: long): boolean;

function UnLockRecords (recArray: pRecordLock): boolean;
function SelectInput (fh: BPTR): BPTR;
function SelectOutput (fh: BPTR): BPTR;
function FGetC (fh: BPTR): longint;
function FPutC
		(fh: BPTR;
		ch: byte): longint;

function UnGetC
		(fh: BPTR;
		character: longint): longint;

function FRead
		(fh: BPTR;
		block: STRPTR;
		blocklen: long;
		number: long): longint;

function FWrite
		(fh: BPTR;
		block: STRPTR;
		blocklen: long;
		number: long): longint;

function FGets
		(fh: BPTR;
		buf: STRPTR;
		buflen: long): STRPTR;

function FPuts
		(fh: BPTR;
		str: STRPTR): longint;

function VFWritef
		(fh: BPTR;
		format: STRPTR;
		argarray: plongint): longint;

function VFPrintf
		(fh: BPTR;
		format: STRPTR;
		argarray: plongint): longint;

function Flush (fh: BPTR): boolean;
function SetVBuf
		(fh: BPTR;
		buff: STRPTR;
		type_: longint;
		size: longint): longint;

function DupLockFromFH (fh: BPTR): BPTR;
function OpenFromLock (lock: BPTR): BPTR;
function ParentOfFH (fh: BPTR): BPTR;
function ExamineFH
		(fh: BPTR;
		fib: pFileInfoBlock): boolean;

function SetFileDate
		(name: STRPTR;
		date: pDateStamp): boolean;

function NameFromLock
		(lock: BPTR;
		buffer: STRPTR;
		len: longint): boolean;

function NameFromFH
		(fh: BPTR;
		buffer: STRPTR;
		len: longint): boolean;

function SplitName
		(name: STRPTR;
		seperator: byte;
		buf: STRPTR;
		oldpos: integer;
		size: longint): integer;

function SameLock
		(lock1: BPTR;
		lock2: BPTR): longint;

function SetMode
		(fh: BPTR;
		mode: longint): boolean;

function ExAll
		(lock: BPTR;
		buffer: STRPTR;
		size: longint;
		data: longint;
		control: pExAllControl): boolean;

function ReadLink
		(port: pMsgPort;
		lock: BPTR;
		path: STRPTR;
		buffer: STRPTR;
		size: long): boolean;

function MakeLink
		(name: STRPTR;
		dest: longint;
		soft: longint): boolean;

function ChangeMode
		(type_: long;
		fh: BPTR;
		newmode: long): boolean;

function SetFileSize
		(fh: BPTR;
		pos: longint;
		mode: longint): longint;

function SetIoErr (result: longint): longint;
function Fault
		(code: longint;
		header: STRPTR;
		buffer: STRPTR;
		len: longint): boolean;

function PrintFault
		(code: longint;
		header: STRPTR): boolean;

function ErrorReport
		(code: longint;
		type_: longint;
		arg1: long;
		device: pMsgPort): boolean;

function Cli: pCommandLineInterface;
function CreateNewProc (tags: pTagItem): pProcess;
function RunCommand
		(seg: BPTR;
		stack: long;
		paramptr: STRPTR;
		paramlen: long): longint;

function GetConsoleTask: pMsgPort;
function SetConsoleTask (task: pMsgPort): pMsgPort;
function GetFileSysTask: pMsgPort;
function SetFileSysTask (task: pMsgPort): pMsgPort;
function GetArgStr: STRPTR;
function SetArgStr (string_: STRPTR): STRPTR;
function FindCliProc (num: longint): pProcess;
function MaxCli: longint;
function SetCurrentDirName (name: STRPTR): boolean;
function GetCurrentDirName
		(buf: STRPTR;
		len: longint): boolean;

function SetProgramName (name: STRPTR): boolean;
function GetProgramName
		(buf: STRPTR;
		len: longint): boolean;

function SetPrompt (name: STRPTR): boolean;
function GetPrompt
		(buf: STRPTR;
		len: longint): boolean;

function SetProgramDir (lock: BPTR): BPTR;
function GetProgramDir: BPTR;
function SystemTagList
		(command: STRPTR;
		tags: pTagItem): longint;

function AssignLock
		(name: STRPTR;
		lock: BPTR): boolean;

function AssignLate
		(name: STRPTR;
		path: STRPTR): boolean;

function AssignPath
		(name: STRPTR;
		path: STRPTR): boolean;

function AssignAdd
		(name: STRPTR;
		lock: BPTR): boolean;

function RemAssignList
		(name: STRPTR;
		lock: BPTR): boolean;

function GetDeviceProc
		(name: STRPTR;
		dp: pDevProc): pDevProc;

procedure FreeDeviceProc (dp: pDevProc);
function LockDosList (flags: long): pDosList;
procedure UnLockDosList (flags: long);
function AttemptLockDosList (flags: long): pDosList;
function RemDosEntry (dlist: pDosList): boolean;
function AddDosEntry (dlist: pDosList): boolean;
function FindDosEntry
		(dlist: pDosList;
		name: STRPTR;
		flags: long): pDosList;

function NextDosEntry
		(dlist: pDosList;
		flags: long): pDosList;

function MakeDosEntry
		(name: STRPTR;
		type_: longint): pDosList;

procedure FreeDosEntry (dlist: pDosList);
function IsFileSystem (name: STRPTR): boolean;
function Format
		(filesystem: STRPTR;
		volumename: STRPTR;
		dostype: long): boolean;

function Relabel
		(drive: STRPTR;
		newname: STRPTR): boolean;

function Inhibit
		(name: STRPTR;
		onoff: longint): boolean;

function AddBuffers
		(name: STRPTR;
		number: longint): boolean;

function CompareDates
		(date1: pDateStamp;
		date2: pDateStamp): longint;

function DateToStr (datetime: pDateTime): boolean;
function StrToDate (datetime: pDateTime): boolean;
function InternalLoadSeg
		(fh: BPTR;
		table: BPTR;
		funcarray: plongint;
		stack: plongint): BPTR;

function InternalUnLoadSeg
		(seglist: BPTR;
		freefunc: pointer): boolean;

function NewLoadSeg
		(file_: STRPTR;
		tags: pTagItem): BPTR;

function AddSegment
		(name: STRPTR;
		seg: BPTR;
		system: longint): boolean;

function FindSegment
		(name: STRPTR;
		seg: pSegment;
		system: longint): pSegment;

function RemSegment (seg: pSegment): boolean;
function CheckSignal (mask: long): long;
function ReadArgs
		(template: STRPTR;
		array_: plongint;
		args: pRDArgs): pRDArgs;

function FindArg
		(keyword: STRPTR;
		template: STRPTR): longint;

function ReadItem
		(name: STRPTR;
		maxchars: longint;
		cSource: pCSource): longint;

function StrToLong
		(string_: STRPTR;
		value: plongint): longint;

function MatchFirst
		(pat: STRPTR;
		anchor: pAnchorPath): longint;

function MatchNext (anchor: pAnchorPath): longint;
procedure MatchEnd (anchor: pAnchorPath);
function ParsePattern
		(pat: STRPTR;
		buf: STRPTR;
		buflen: longint): longint;

function MatchPattern
		(pat: STRPTR;
		str: STRPTR): boolean;

procedure FreeArgs (args: pRDArgs);
function FilePart (path: STRPTR): STRPTR;
function PathPart (path: STRPTR): STRPTR;
function AddPart
		(dirname: STRPTR;
		filename: STRPTR;
		size: long): boolean;

function StartNotify (notify: pNotifyRequest): boolean;
procedure EndNotify (notify: pNotifyRequest);
function SetVar
		(name: STRPTR;
		buffer: STRPTR;
		size: longint;
		flags: long): boolean;

function GetVar
		(name: STRPTR;
		buffer: STRPTR;
		size: longint;
		flags: long): longint;

function DeleteVar
		(name: STRPTR;
		flags: long): boolean;

function FindVar
		(name: STRPTR;
		type_: long): pLocalVar;

function CliInitNewcli (dp: pDosPacket): longint;
function CliInitRun (dp: pDosPacket): longint;
function WriteChars
		(buf: STRPTR;
		buflen: longint): longint;

function PutStr (str: STRPTR): longint;
function VPrintf
		(format: STRPTR;
		argarray: plongint): longint;

function ParsePatternNoCase
		(pat: STRPTR;
		buf: STRPTR;
		buflen: longint): longint;

function MatchPatternNoCase
		(pat: STRPTR;
		str: STRPTR): boolean;

function SameDevice
		(lock1: BPTR;
		lock2: BPTR): boolean;



function BADDR (bval: BPTR): pointer;
inline
	$201F,		{ move.l (sp)+,d0	}
	$E580,		{ asl.l  #2,d0		}
	$2E80;		{ move.l d0,(sp)	}

function MKBADDR (addr: pointer): BPTR;
inline
	$201F,		{ move.l (sp)+,d0	}
	$E480,		{ asr.l  #2,d0		}
	$2E80;		{ move.l d0,(sp)	}


IMPLEMENTATION
function Open; xassembler;
asm
	move.l	a6,-(sp)
	lea		8(sp),a6
	move.l	(a6)+,d2
	move.l	(a6)+,d1
	move.l	DOSBase,a6
	jsr		-$1E(a6)
	move.l	d0,$10(sp)
	move.l	(sp)+,a6
end;

function Close_; xassembler;
asm
	move.l	a6,-(sp)
	move.l	8(sp),d1
	move.l	DOSBase,a6
	jsr		-$24(a6)
	tst.l	d0
	sne		d0
	neg.b	d0
	move.b	d0,$C(sp)
	move.l	(sp)+,a6
end;

function Read_; xassembler;
asm
	movem.l	d3/a6,-(sp)
	lea		$C(sp),a6
	move.l	(a6)+,d3
	move.l	(a6)+,d2
	move.l	(a6)+,d1
	move.l	DOSBase,a6
	jsr		-$2A(a6)
	move.l	d0,$18(sp)
	movem.l	(sp)+,d3/a6
end;

function Write_; xassembler;
asm
	movem.l	d3/a6,-(sp)
	lea		$C(sp),a6
	move.l	(a6)+,d3
	move.l	(a6)+,d2
	move.l	(a6)+,d1
	move.l	DOSBase,a6
	jsr		-$30(a6)
	move.l	d0,$18(sp)
	movem.l	(sp)+,d3/a6
end;

function Input_; xassembler;
asm
	movem.l	d3/a6,-(sp)
	move.l	DOSBase,a6
	jsr		-$36(a6)
	move.l	d0,$C(sp)
	movem.l	(sp)+,d3/a6
end;

function Output_; xassembler;
asm
	movem.l	d3/a6,-(sp)
	move.l	DOSBase,a6
	jsr		-$3C(a6)
	move.l	d0,$C(sp)
	movem.l	(sp)+,d3/a6
end;

function Seek_; xassembler;
asm
	movem.l	d3/a6,-(sp)
	lea		$C(sp),a6
	move.l	(a6)+,d3
	move.l	(a6)+,d2
	move.l	(a6)+,d1
	move.l	DOSBase,a6
	jsr		-$42(a6)
	move.l	d0,$18(sp)
	movem.l	(sp)+,d3/a6
end;

function DeleteFile; xassembler;
asm
	move.l	a6,-(sp)
	move.l	8(sp),d1
	move.l	DOSBase,a6
	jsr		-$48(a6)
	tst.l	d0
	sne		d0
	neg.b	d0
	move.b	d0,$C(sp)
	move.l	(sp)+,a6
end;

function Rename_; xassembler;
asm
	move.l	a6,-(sp)
	lea		8(sp),a6
	move.l	(a6)+,d2
	move.l	(a6)+,d1
	move.l	DOSBase,a6
	jsr		-$4E(a6)
	tst.l	d0
	sne		d0
	neg.b	d0
	move.b	d0,$10(sp)
	move.l	(sp)+,a6
end;

function Lock; xassembler;
asm
	move.l	a6,-(sp)
	lea		8(sp),a6
	move.l	(a6)+,d2
	move.l	(a6)+,d1
	move.l	DOSBase,a6
	jsr		-$54(a6)
	move.l	d0,$10(sp)
	move.l	(sp)+,a6
end;

procedure UnLock; xassembler;
asm
	move.l	a6,-(sp)
	move.l	8(sp),d1
	move.l	DOSBase,a6
	jsr		-$5A(a6)
	move.l	(sp)+,a6
end;

function DupLock; xassembler;
asm
	move.l	a6,-(sp)
	move.l	8(sp),d1
	move.l	DOSBase,a6
	jsr		-$60(a6)
	move.l	d0,$C(sp)
	move.l	(sp)+,a6
end;

function Examine; xassembler;
asm
	move.l	a6,-(sp)
	lea		8(sp),a6
	move.l	(a6)+,d2
	move.l	(a6)+,d1
	move.l	DOSBase,a6
	jsr		-$66(a6)
	tst.l	d0
	sne		d0
	neg.b	d0
	move.b	d0,$10(sp)
	move.l	(sp)+,a6
end;

function ExNext; xassembler;
asm
	move.l	a6,-(sp)
	lea		8(sp),a6
	move.l	(a6)+,d2
	move.l	(a6)+,d1
	move.l	DOSBase,a6
	jsr		-$6C(a6)
	tst.l	d0
	sne		d0
	neg.b	d0
	move.b	d0,$10(sp)
	move.l	(sp)+,a6
end;

function Info; xassembler;
asm
	move.l	a6,-(sp)
	lea		8(sp),a6
	move.l	(a6)+,d2
	move.l	(a6)+,d1
	move.l	DOSBase,a6
	jsr		-$72(a6)
	tst.l	d0
	sne		d0
	neg.b	d0
	move.b	d0,$10(sp)
	move.l	(sp)+,a6
end;

function CreateDir; xassembler;
asm
	move.l	a6,-(sp)
	move.l	8(sp),d1
	move.l	DOSBase,a6
	jsr		-$78(a6)
	move.l	d0,$C(sp)
	move.l	(sp)+,a6
end;

function CurrentDir; xassembler;
asm
	move.l	a6,-(sp)
	move.l	8(sp),d1
	move.l	DOSBase,a6
	jsr		-$7E(a6)
	move.l	d0,$C(sp)
	move.l	(sp)+,a6
end;

function IoErr; xassembler;
asm
	move.l	a6,-(sp)
	move.l	DOSBase,a6
	jsr		-$84(a6)
	move.l	d0,8(sp)
	move.l	(sp)+,a6
end;

function CreateProc; xassembler;
asm
	movem.l	d3-d4/a6,-(sp)
	lea		$10(sp),a6
	move.l	(a6)+,d4
	move.l	(a6)+,d3
	move.l	(a6)+,d2
	move.l	(a6)+,d1
	move.l	DOSBase,a6
	jsr		-$8A(a6)
	move.l	d0,$20(sp)
	movem.l	(sp)+,d3-d4/a6
end;

procedure Exit_; xassembler;
asm
	move.l	a6,-(sp)
	move.l	8(sp),d1
	move.l	DOSBase,a6
	jsr		-$90(a6)
	move.l	(sp)+,a6
end;

function LoadSeg; xassembler;
asm
	move.l	a6,-(sp)
	move.l	8(sp),d1
	move.l	DOSBase,a6
	jsr		-$96(a6)
	move.l	d0,$C(sp)
	move.l	(sp)+,a6
end;

function UnLoadSeg; xassembler;
asm
	move.l	a6,-(sp)
	move.l	8(sp),d1
	move.l	DOSBase,a6
	jsr		-$9C(a6)
	tst.l	d0
	sne		d0
	neg.b	d0
	move.b	d0,$C(sp)
	move.l	(sp)+,a6
end;

function DeviceProc; xassembler;
asm
	move.l	a6,-(sp)
	move.l	8(sp),d1
	move.l	DOSBase,a6
	jsr		-$AE(a6)
	move.l	d0,$C(sp)
	move.l	(sp)+,a6
end;

function SetComment; xassembler;
asm
	move.l	a6,-(sp)
	lea		8(sp),a6
	move.l	(a6)+,d2
	move.l	(a6)+,d1
	move.l	DOSBase,a6
	jsr		-$B4(a6)
	tst.l	d0
	sne		d0
	neg.b	d0
	move.b	d0,$10(sp)
	move.l	(sp)+,a6
end;

function SetProtection; xassembler;
asm
	move.l	a6,-(sp)
	lea		8(sp),a6
	move.l	(a6)+,d2
	move.l	(a6)+,d1
	move.l	DOSBase,a6
	jsr		-$BA(a6)
	tst.l	d0
	sne		d0
	neg.b	d0
	move.b	d0,$10(sp)
	move.l	(sp)+,a6
end;

function DateStamp; xassembler;
asm
	move.l	a6,-(sp)
	move.l	8(sp),d1
	move.l	DOSBase,a6
	jsr		-$C0(a6)
	move.l	d0,$C(sp)
	move.l	(sp)+,a6
end;

procedure Delay_; xassembler;
asm
	move.l	a6,-(sp)
	move.l	8(sp),d1
	move.l	DOSBase,a6
	jsr		-$C6(a6)
	move.l	(sp)+,a6
end;

function WaitForChar; xassembler;
asm
	move.l	a6,-(sp)
	lea		8(sp),a6
	move.l	(a6)+,d2
	move.l	(a6)+,d1
	move.l	DOSBase,a6
	jsr		-$CC(a6)
	tst.l	d0
	sne		d0
	neg.b	d0
	move.b	d0,$10(sp)
	move.l	(sp)+,a6
end;

function ParentDir; xassembler;
asm
	move.l	a6,-(sp)
	move.l	8(sp),d1
	move.l	DOSBase,a6
	jsr		-$D2(a6)
	move.l	d0,$C(sp)
	move.l	(sp)+,a6
end;

function IsInteractive; xassembler;
asm
	move.l	a6,-(sp)
	move.l	8(sp),d1
	move.l	DOSBase,a6
	jsr		-$D8(a6)
	tst.l	d0
	sne		d0
	neg.b	d0
	move.b	d0,$C(sp)
	move.l	(sp)+,a6
end;

function Execute; xassembler;
asm
	movem.l	d3/a6,-(sp)
	lea		$C(sp),a6
	move.l	(a6)+,d3
	move.l	(a6)+,d2
	move.l	(a6)+,d1
	move.l	DOSBase,a6
	jsr		-$DE(a6)
	tst.l	d0
	sne		d0
	neg.b	d0
	move.b	d0,$18(sp)
	movem.l	(sp)+,d3/a6
end;

function AllocDosObject; xassembler;
asm
	move.l	a6,-(sp)
	lea		8(sp),a6
	move.l	(a6)+,d2
	move.l	(a6)+,d1
	move.l	DOSBase,a6
	jsr		-$E4(a6)
	move.l	d0,$10(sp)
	move.l	(sp)+,a6
end;

procedure FreeDosObject; xassembler;
asm
	move.l	a6,-(sp)
	lea		8(sp),a6
	move.l	(a6)+,d2
	move.l	(a6)+,d1
	move.l	DOSBase,a6
	jsr		-$EA(a6)
	move.l	(sp)+,a6
end;

function DoPkt; xassembler;
asm
	movem.l	d3-d7/a6,-(sp)
	lea		$1C(sp),a6
	move.l	(a6)+,d7
	move.l	(a6)+,d6
	move.l	(a6)+,d5
	move.l	(a6)+,d4
	move.l	(a6)+,d3
	move.l	(a6)+,d2
	move.l	(a6)+,d1
	move.l	DOSBase,a6
	jsr		-$F0(a6)
	move.l	d0,$38(sp)
	movem.l	(sp)+,d3-d7/a6
end;

procedure SendPkt; xassembler;
asm
	movem.l	d3/a6,-(sp)
	lea		$C(sp),a6
	move.l	(a6)+,d3
	move.l	(a6)+,d2
	move.l	(a6)+,d1
	move.l	DOSBase,a6
	jsr		-$F6(a6)
	movem.l	(sp)+,d3/a6
end;

function WaitPkt; xassembler;
asm
	movem.l	d3/a6,-(sp)
	move.l	DOSBase,a6
	jsr		-$FC(a6)
	move.l	d0,$C(sp)
	movem.l	(sp)+,d3/a6
end;

procedure ReplyPkt; xassembler;
asm
	movem.l	d3/a6,-(sp)
	lea		$C(sp),a6
	move.l	(a6)+,d3
	move.l	(a6)+,d2
	move.l	(a6)+,d1
	move.l	DOSBase,a6
	jsr		-$102(a6)
	movem.l	(sp)+,d3/a6
end;

procedure AbortPkt; xassembler;
asm
	move.l	a6,-(sp)
	lea		8(sp),a6
	move.l	(a6)+,d2
	move.l	(a6)+,d1
	move.l	DOSBase,a6
	jsr		-$108(a6)
	move.l	(sp)+,a6
end;

function LockRecord; xassembler;
asm
	movem.l	d3-d5/a6,-(sp)
	lea		$14(sp),a6
	move.l	(a6)+,d5
	move.l	(a6)+,d4
	move.l	(a6)+,d3
	move.l	(a6)+,d2
	move.l	(a6)+,d1
	move.l	DOSBase,a6
	jsr		-$10E(a6)
	move.l	d0,$28(sp)
	movem.l	(sp)+,d3-d5/a6
end;

function LockRecords; xassembler;
asm
	move.l	a6,-(sp)
	lea		8(sp),a6
	move.l	(a6)+,d2
	move.l	(a6)+,d1
	move.l	DOSBase,a6
	jsr		-$114(a6)
	tst.l	d0
	sne		d0
	neg.b	d0
	move.b	d0,$10(sp)
	move.l	(sp)+,a6
end;

function UnLockRecord; xassembler;
asm
	movem.l	d3/a6,-(sp)
	lea		$C(sp),a6
	move.l	(a6)+,d3
	move.l	(a6)+,d2
	move.l	(a6)+,d1
	move.l	DOSBase,a6
	jsr		-$11A(a6)
	tst.l	d0
	sne		d0
	neg.b	d0
	move.b	d0,$18(sp)
	movem.l	(sp)+,d3/a6
end;

function UnLockRecords; xassembler;
asm
	move.l	a6,-(sp)
	move.l	8(sp),d1
	move.l	DOSBase,a6
	jsr		-$120(a6)
	tst.l	d0
	sne		d0
	neg.b	d0
	move.b	d0,$C(sp)
	move.l	(sp)+,a6
end;

function SelectInput; xassembler;
asm
	move.l	a6,-(sp)
	move.l	8(sp),d1
	move.l	DOSBase,a6
	jsr		-$126(a6)
	move.l	d0,$C(sp)
	move.l	(sp)+,a6
end;

function SelectOutput; xassembler;
asm
	move.l	a6,-(sp)
	move.l	8(sp),d1
	move.l	DOSBase,a6
	jsr		-$12C(a6)
	move.l	d0,$C(sp)
	move.l	(sp)+,a6
end;

function FGetC; xassembler;
asm
	move.l	a6,-(sp)
	move.l	8(sp),d1
	move.l	DOSBase,a6
	jsr		-$132(a6)
	move.l	d0,$C(sp)
	move.l	(sp)+,a6
end;

function FPutC; xassembler;
asm
	move.l	a6,-(sp)
	move.b	8(sp),d2
	move.l	$A(sp),d1
	move.l	DOSBase,a6
	jsr		-$138(a6)
	move.l	d0,$E(sp)
	move.l	(sp)+,a6
end;

function UnGetC; xassembler;
asm
	move.l	a6,-(sp)
	lea		8(sp),a6
	move.l	(a6)+,d2
	move.l	(a6)+,d1
	move.l	DOSBase,a6
	jsr		-$13E(a6)
	move.l	d0,$10(sp)
	move.l	(sp)+,a6
end;

function FRead; xassembler;
asm
	movem.l	d3-d4/a6,-(sp)
	lea		$10(sp),a6
	move.l	(a6)+,d4
	move.l	(a6)+,d3
	move.l	(a6)+,d2
	move.l	(a6)+,d1
	move.l	DOSBase,a6
	jsr		-$144(a6)
	move.l	d0,$20(sp)
	movem.l	(sp)+,d3-d4/a6
end;

function FWrite; xassembler;
asm
	movem.l	d3-d4/a6,-(sp)
	lea		$10(sp),a6
	move.l	(a6)+,d4
	move.l	(a6)+,d3
	move.l	(a6)+,d2
	move.l	(a6)+,d1
	move.l	DOSBase,a6
	jsr		-$14A(a6)
	move.l	d0,$20(sp)
	movem.l	(sp)+,d3-d4/a6
end;

function FGets; xassembler;
asm
	movem.l	d3/a6,-(sp)
	lea		$C(sp),a6
	move.l	(a6)+,d3
	move.l	(a6)+,d2
	move.l	(a6)+,d1
	move.l	DOSBase,a6
	jsr		-$150(a6)
	move.l	d0,$18(sp)
	movem.l	(sp)+,d3/a6
end;

function FPuts; xassembler;
asm
	move.l	a6,-(sp)
	lea		8(sp),a6
	move.l	(a6)+,d2
	move.l	(a6)+,d1
	move.l	DOSBase,a6
	jsr		-$156(a6)
	move.l	d0,$10(sp)
	move.l	(sp)+,a6
end;

function VFWritef; xassembler;
asm
	movem.l	d3/a6,-(sp)
	lea		$C(sp),a6
	move.l	(a6)+,d3
	move.l	(a6)+,d2
	move.l	(a6)+,d1
	move.l	DOSBase,a6
	jsr		-$15C(a6)
	move.l	d0,$18(sp)
	movem.l	(sp)+,d3/a6
end;

function VFPrintf; xassembler;
asm
	movem.l	d3/a6,-(sp)
	lea		$C(sp),a6
	move.l	(a6)+,d3
	move.l	(a6)+,d2
	move.l	(a6)+,d1
	move.l	DOSBase,a6
	jsr		-$162(a6)
	move.l	d0,$18(sp)
	movem.l	(sp)+,d3/a6
end;

function Flush; xassembler;
asm
	move.l	a6,-(sp)
	move.l	8(sp),d1
	move.l	DOSBase,a6
	jsr		-$168(a6)
	tst.l	d0
	sne		d0
	neg.b	d0
	move.b	d0,$C(sp)
	move.l	(sp)+,a6
end;

function SetVBuf; xassembler;
asm
	movem.l	d3-d4/a6,-(sp)
	lea		$10(sp),a6
	move.l	(a6)+,d4
	move.l	(a6)+,d3
	move.l	(a6)+,d2
	move.l	(a6)+,d1
	move.l	DOSBase,a6
	jsr		-$16E(a6)
	move.l	d0,$20(sp)
	movem.l	(sp)+,d3-d4/a6
end;

function DupLockFromFH; xassembler;
asm
	move.l	a6,-(sp)
	move.l	8(sp),d1
	move.l	DOSBase,a6
	jsr		-$174(a6)
	move.l	d0,$C(sp)
	move.l	(sp)+,a6
end;

function OpenFromLock; xassembler;
asm
	move.l	a6,-(sp)
	move.l	8(sp),d1
	move.l	DOSBase,a6
	jsr		-$17A(a6)
	move.l	d0,$C(sp)
	move.l	(sp)+,a6
end;

function ParentOfFH; xassembler;
asm
	move.l	a6,-(sp)
	move.l	8(sp),d1
	move.l	DOSBase,a6
	jsr		-$180(a6)
	move.l	d0,$C(sp)
	move.l	(sp)+,a6
end;

function ExamineFH; xassembler;
asm
	move.l	a6,-(sp)
	lea		8(sp),a6
	move.l	(a6)+,d2
	move.l	(a6)+,d1
	move.l	DOSBase,a6
	jsr		-$186(a6)
	tst.l	d0
	sne		d0
	neg.b	d0
	move.b	d0,$10(sp)
	move.l	(sp)+,a6
end;

function SetFileDate; xassembler;
asm
	move.l	a6,-(sp)
	lea		8(sp),a6
	move.l	(a6)+,d2
	move.l	(a6)+,d1
	move.l	DOSBase,a6
	jsr		-$18C(a6)
	tst.l	d0
	sne		d0
	neg.b	d0
	move.b	d0,$10(sp)
	move.l	(sp)+,a6
end;

function NameFromLock; xassembler;
asm
	movem.l	d3/a6,-(sp)
	lea		$C(sp),a6
	move.l	(a6)+,d3
	move.l	(a6)+,d2
	move.l	(a6)+,d1
	move.l	DOSBase,a6
	jsr		-$192(a6)
	tst.l	d0
	sne		d0
	neg.b	d0
	move.b	d0,$18(sp)
	movem.l	(sp)+,d3/a6
end;

function NameFromFH; xassembler;
asm
	movem.l	d3/a6,-(sp)
	lea		$C(sp),a6
	move.l	(a6)+,d3
	move.l	(a6)+,d2
	move.l	(a6)+,d1
	move.l	DOSBase,a6
	jsr		-$198(a6)
	tst.l	d0
	sne		d0
	neg.b	d0
	move.b	d0,$18(sp)
	movem.l	(sp)+,d3/a6
end;

function SplitName; xassembler;
asm
	movem.l	d3-d5/a6,-(sp)
	lea		$14(sp),a6
	move.l	(a6)+,d5
	move.w	(a6)+,d4
	move.l	(a6)+,d3
	move.b	(a6)+,d2
	addq.l	#1,a6
	move.l	(a6)+,d1
	move.l	DOSBase,a6
	jsr		-$19E(a6)
	move.w	d0,$24(sp)
	movem.l	(sp)+,d3-d5/a6
end;

function SameLock; xassembler;
asm
	move.l	a6,-(sp)
	lea		8(sp),a6
	move.l	(a6)+,d2
	move.l	(a6)+,d1
	move.l	DOSBase,a6
	jsr		-$1A4(a6)
	move.l	d0,$10(sp)
	move.l	(sp)+,a6
end;

function SetMode; xassembler;
asm
	move.l	a6,-(sp)
	lea		8(sp),a6
	move.l	(a6)+,d2
	move.l	(a6)+,d1
	move.l	DOSBase,a6
	jsr		-$1AA(a6)
	tst.l	d0
	sne		d0
	neg.b	d0
	move.b	d0,$10(sp)
	move.l	(sp)+,a6
end;

function ExAll; xassembler;
asm
	movem.l	d3-d5/a6,-(sp)
	lea		$14(sp),a6
	move.l	(a6)+,d5
	move.l	(a6)+,d4
	move.l	(a6)+,d3
	move.l	(a6)+,d2
	move.l	(a6)+,d1
	move.l	DOSBase,a6
	jsr		-$1B0(a6)
	tst.l	d0
	sne		d0
	neg.b	d0
	move.b	d0,$28(sp)
	movem.l	(sp)+,d3-d5/a6
end;

function ReadLink; xassembler;
asm
	movem.l	d3-d5/a6,-(sp)
	lea		$14(sp),a6
	move.l	(a6)+,d5
	move.l	(a6)+,d4
	move.l	(a6)+,d3
	move.l	(a6)+,d2
	move.l	(a6)+,d1
	move.l	DOSBase,a6
	jsr		-$1B6(a6)
	tst.l	d0
	sne		d0
	neg.b	d0
	move.b	d0,$28(sp)
	movem.l	(sp)+,d3-d5/a6
end;

function MakeLink; xassembler;
asm
	movem.l	d3/a6,-(sp)
	lea		$C(sp),a6
	move.l	(a6)+,d3
	move.l	(a6)+,d2
	move.l	(a6)+,d1
	move.l	DOSBase,a6
	jsr		-$1BC(a6)
	tst.l	d0
	sne		d0
	neg.b	d0
	move.b	d0,$18(sp)
	movem.l	(sp)+,d3/a6
end;

function ChangeMode; xassembler;
asm
	movem.l	d3/a6,-(sp)
	lea		$C(sp),a6
	move.l	(a6)+,d3
	move.l	(a6)+,d2
	move.l	(a6)+,d1
	move.l	DOSBase,a6
	jsr		-$1C2(a6)
	tst.l	d0
	sne		d0
	neg.b	d0
	move.b	d0,$18(sp)
	movem.l	(sp)+,d3/a6
end;

function SetFileSize; xassembler;
asm
	movem.l	d3/a6,-(sp)
	lea		$C(sp),a6
	move.l	(a6)+,d3
	move.l	(a6)+,d2
	move.l	(a6)+,d1
	move.l	DOSBase,a6
	jsr		-$1C8(a6)
	move.l	d0,$18(sp)
	movem.l	(sp)+,d3/a6
end;

function SetIoErr; xassembler;
asm
	move.l	a6,-(sp)
	move.l	8(sp),d1
	move.l	DOSBase,a6
	jsr		-$1CE(a6)
	move.l	d0,$C(sp)
	move.l	(sp)+,a6
end;

function Fault; xassembler;
asm
	movem.l	d3-d4/a6,-(sp)
	lea		$10(sp),a6
	move.l	(a6)+,d4
	move.l	(a6)+,d3
	move.l	(a6)+,d2
	move.l	(a6)+,d1
	move.l	DOSBase,a6
	jsr		-$1D4(a6)
	tst.l	d0
	sne		d0
	neg.b	d0
	move.b	d0,$20(sp)
	movem.l	(sp)+,d3-d4/a6
end;

function PrintFault; xassembler;
asm
	move.l	a6,-(sp)
	lea		8(sp),a6
	move.l	(a6)+,d2
	move.l	(a6)+,d1
	move.l	DOSBase,a6
	jsr		-$1DA(a6)
	tst.l	d0
	sne		d0
	neg.b	d0
	move.b	d0,$10(sp)
	move.l	(sp)+,a6
end;

function ErrorReport; xassembler;
asm
	movem.l	d3-d4/a6,-(sp)
	lea		$10(sp),a6
	move.l	(a6)+,d4
	move.l	(a6)+,d3
	move.l	(a6)+,d2
	move.l	(a6)+,d1
	move.l	DOSBase,a6
	jsr		-$1E0(a6)
	tst.l	d0
	sne		d0
	neg.b	d0
	move.b	d0,$20(sp)
	movem.l	(sp)+,d3-d4/a6
end;

function Cli; xassembler;
asm
	movem.l	d3-d4/a6,-(sp)
	move.l	DOSBase,a6
	jsr		-$1EC(a6)
	move.l	d0,$10(sp)
	movem.l	(sp)+,d3-d4/a6
end;

function CreateNewProc; xassembler;
asm
	move.l	a6,-(sp)
	move.l	8(sp),d1
	move.l	DOSBase,a6
	jsr		-$1F2(a6)
	move.l	d0,$C(sp)
	move.l	(sp)+,a6
end;

function RunCommand; xassembler;
asm
	movem.l	d3-d4/a6,-(sp)
	lea		$10(sp),a6
	move.l	(a6)+,d4
	move.l	(a6)+,d3
	move.l	(a6)+,d2
	move.l	(a6)+,d1
	move.l	DOSBase,a6
	jsr		-$1F8(a6)
	move.l	d0,$20(sp)
	movem.l	(sp)+,d3-d4/a6
end;

function GetConsoleTask; xassembler;
asm
	movem.l	d3-d4/a6,-(sp)
	move.l	DOSBase,a6
	jsr		-$1FE(a6)
	move.l	d0,$10(sp)
	movem.l	(sp)+,d3-d4/a6
end;

function SetConsoleTask; xassembler;
asm
	move.l	a6,-(sp)
	move.l	8(sp),d1
	move.l	DOSBase,a6
	jsr		-$204(a6)
	move.l	d0,$C(sp)
	move.l	(sp)+,a6
end;

function GetFileSysTask; xassembler;
asm
	move.l	a6,-(sp)
	move.l	DOSBase,a6
	jsr		-$20A(a6)
	move.l	d0,8(sp)
	move.l	(sp)+,a6
end;

function SetFileSysTask; xassembler;
asm
	move.l	a6,-(sp)
	move.l	8(sp),d1
	move.l	DOSBase,a6
	jsr		-$210(a6)
	move.l	d0,$C(sp)
	move.l	(sp)+,a6
end;

function GetArgStr; xassembler;
asm
	move.l	a6,-(sp)
	move.l	DOSBase,a6
	jsr		-$216(a6)
	move.l	d0,8(sp)
	move.l	(sp)+,a6
end;

function SetArgStr; xassembler;
asm
	move.l	a6,-(sp)
	move.l	8(sp),d1
	move.l	DOSBase,a6
	jsr		-$21C(a6)
	move.l	d0,$C(sp)
	move.l	(sp)+,a6
end;

function FindCliProc; xassembler;
asm
	move.l	a6,-(sp)
	move.l	8(sp),d1
	move.l	DOSBase,a6
	jsr		-$222(a6)
	move.l	d0,$C(sp)
	move.l	(sp)+,a6
end;

function MaxCli; xassembler;
asm
	move.l	a6,-(sp)
	move.l	DOSBase,a6
	jsr		-$228(a6)
	move.l	d0,8(sp)
	move.l	(sp)+,a6
end;

function SetCurrentDirName; xassembler;
asm
	move.l	a6,-(sp)
	move.l	8(sp),d1
	move.l	DOSBase,a6
	jsr		-$22E(a6)
	tst.l	d0
	sne		d0
	neg.b	d0
	move.b	d0,$C(sp)
	move.l	(sp)+,a6
end;

function GetCurrentDirName; xassembler;
asm
	move.l	a6,-(sp)
	lea		8(sp),a6
	move.l	(a6)+,d2
	move.l	(a6)+,d1
	move.l	DOSBase,a6
	jsr		-$234(a6)
	tst.l	d0
	sne		d0
	neg.b	d0
	move.b	d0,$10(sp)
	move.l	(sp)+,a6
end;

function SetProgramName; xassembler;
asm
	move.l	a6,-(sp)
	move.l	8(sp),d1
	move.l	DOSBase,a6
	jsr		-$23A(a6)
	tst.l	d0
	sne		d0
	neg.b	d0
	move.b	d0,$C(sp)
	move.l	(sp)+,a6
end;

function GetProgramName; xassembler;
asm
	move.l	a6,-(sp)
	lea		8(sp),a6
	move.l	(a6)+,d2
	move.l	(a6)+,d1
	move.l	DOSBase,a6
	jsr		-$240(a6)
	tst.l	d0
	sne		d0
	neg.b	d0
	move.b	d0,$10(sp)
	move.l	(sp)+,a6
end;

function SetPrompt; xassembler;
asm
	move.l	a6,-(sp)
	move.l	8(sp),d1
	move.l	DOSBase,a6
	jsr		-$246(a6)
	tst.l	d0
	sne		d0
	neg.b	d0
	move.b	d0,$C(sp)
	move.l	(sp)+,a6
end;

function GetPrompt; xassembler;
asm
	move.l	a6,-(sp)
	lea		8(sp),a6
	move.l	(a6)+,d2
	move.l	(a6)+,d1
	move.l	DOSBase,a6
	jsr		-$24C(a6)
	tst.l	d0
	sne		d0
	neg.b	d0
	move.b	d0,$10(sp)
	move.l	(sp)+,a6
end;

function SetProgramDir; xassembler;
asm
	move.l	a6,-(sp)
	move.l	8(sp),d1
	move.l	DOSBase,a6
	jsr		-$252(a6)
	move.l	d0,$C(sp)
	move.l	(sp)+,a6
end;

function GetProgramDir; xassembler;
asm
	move.l	a6,-(sp)
	move.l	DOSBase,a6
	jsr		-$258(a6)
	move.l	d0,8(sp)
	move.l	(sp)+,a6
end;

function SystemTagList; xassembler;
asm
	move.l	a6,-(sp)
	lea		8(sp),a6
	move.l	(a6)+,d2
	move.l	(a6)+,d1
	move.l	DOSBase,a6
	jsr		-$25E(a6)
	move.l	d0,$10(sp)
	move.l	(sp)+,a6
end;

function AssignLock; xassembler;
asm
	move.l	a6,-(sp)
	lea		8(sp),a6
	move.l	(a6)+,d2
	move.l	(a6)+,d1
	move.l	DOSBase,a6
	jsr		-$264(a6)
	tst.l	d0
	sne		d0
	neg.b	d0
	move.b	d0,$10(sp)
	move.l	(sp)+,a6
end;

function AssignLate; xassembler;
asm
	move.l	a6,-(sp)
	lea		8(sp),a6
	move.l	(a6)+,d2
	move.l	(a6)+,d1
	move.l	DOSBase,a6
	jsr		-$26A(a6)
	tst.l	d0
	sne		d0
	neg.b	d0
	move.b	d0,$10(sp)
	move.l	(sp)+,a6
end;

function AssignPath; xassembler;
asm
	move.l	a6,-(sp)
	lea		8(sp),a6
	move.l	(a6)+,d2
	move.l	(a6)+,d1
	move.l	DOSBase,a6
	jsr		-$270(a6)
	tst.l	d0
	sne		d0
	neg.b	d0
	move.b	d0,$10(sp)
	move.l	(sp)+,a6
end;

function AssignAdd; xassembler;
asm
	move.l	a6,-(sp)
	lea		8(sp),a6
	move.l	(a6)+,d2
	move.l	(a6)+,d1
	move.l	DOSBase,a6
	jsr		-$276(a6)
	tst.l	d0
	sne		d0
	neg.b	d0
	move.b	d0,$10(sp)
	move.l	(sp)+,a6
end;

function RemAssignList; xassembler;
asm
	move.l	a6,-(sp)
	lea		8(sp),a6
	move.l	(a6)+,d2
	move.l	(a6)+,d1
	move.l	DOSBase,a6
	jsr		-$27C(a6)
	tst.l	d0
	sne		d0
	neg.b	d0
	move.b	d0,$10(sp)
	move.l	(sp)+,a6
end;

function GetDeviceProc; xassembler;
asm
	move.l	a6,-(sp)
	lea		8(sp),a6
	move.l	(a6)+,d2
	move.l	(a6)+,d1
	move.l	DOSBase,a6
	jsr		-$282(a6)
	move.l	d0,$10(sp)
	move.l	(sp)+,a6
end;

procedure FreeDeviceProc; xassembler;
asm
	move.l	a6,-(sp)
	move.l	8(sp),d1
	move.l	DOSBase,a6
	jsr		-$288(a6)
	move.l	(sp)+,a6
end;

function LockDosList; xassembler;
asm
	move.l	a6,-(sp)
	move.l	8(sp),d1
	move.l	DOSBase,a6
	jsr		-$28E(a6)
	move.l	d0,$C(sp)
	move.l	(sp)+,a6
end;

procedure UnLockDosList; xassembler;
asm
	move.l	a6,-(sp)
	move.l	8(sp),d1
	move.l	DOSBase,a6
	jsr		-$294(a6)
	move.l	(sp)+,a6
end;

function AttemptLockDosList; xassembler;
asm
	move.l	a6,-(sp)
	move.l	8(sp),d1
	move.l	DOSBase,a6
	jsr		-$29A(a6)
	move.l	d0,$C(sp)
	move.l	(sp)+,a6
end;

function RemDosEntry; xassembler;
asm
	move.l	a6,-(sp)
	move.l	8(sp),d1
	move.l	DOSBase,a6
	jsr		-$2A0(a6)
	tst.l	d0
	sne		d0
	neg.b	d0
	move.b	d0,$C(sp)
	move.l	(sp)+,a6
end;

function AddDosEntry; xassembler;
asm
	move.l	a6,-(sp)
	move.l	8(sp),d1
	move.l	DOSBase,a6
	jsr		-$2A6(a6)
	tst.l	d0
	sne		d0
	neg.b	d0
	move.b	d0,$C(sp)
	move.l	(sp)+,a6
end;

function FindDosEntry; xassembler;
asm
	movem.l	d3/a6,-(sp)
	lea		$C(sp),a6
	move.l	(a6)+,d3
	move.l	(a6)+,d2
	move.l	(a6)+,d1
	move.l	DOSBase,a6
	jsr		-$2AC(a6)
	move.l	d0,$18(sp)
	movem.l	(sp)+,d3/a6
end;

function NextDosEntry; xassembler;
asm
	move.l	a6,-(sp)
	lea		8(sp),a6
	move.l	(a6)+,d2
	move.l	(a6)+,d1
	move.l	DOSBase,a6
	jsr		-$2B2(a6)
	move.l	d0,$10(sp)
	move.l	(sp)+,a6
end;

function MakeDosEntry; xassembler;
asm
	move.l	a6,-(sp)
	lea		8(sp),a6
	move.l	(a6)+,d2
	move.l	(a6)+,d1
	move.l	DOSBase,a6
	jsr		-$2B8(a6)
	move.l	d0,$10(sp)
	move.l	(sp)+,a6
end;

procedure FreeDosEntry; xassembler;
asm
	move.l	a6,-(sp)
	move.l	8(sp),d1
	move.l	DOSBase,a6
	jsr		-$2BE(a6)
	move.l	(sp)+,a6
end;

function IsFileSystem; xassembler;
asm
	move.l	a6,-(sp)
	move.l	8(sp),d1
	move.l	DOSBase,a6
	jsr		-$2C4(a6)
	tst.l	d0
	sne		d0
	neg.b	d0
	move.b	d0,$C(sp)
	move.l	(sp)+,a6
end;

function Format; xassembler;
asm
	movem.l	d3/a6,-(sp)
	lea		$C(sp),a6
	move.l	(a6)+,d3
	move.l	(a6)+,d2
	move.l	(a6)+,d1
	move.l	DOSBase,a6
	jsr		-$2CA(a6)
	tst.l	d0
	sne		d0
	neg.b	d0
	move.b	d0,$18(sp)
	movem.l	(sp)+,d3/a6
end;

function Relabel; xassembler;
asm
	move.l	a6,-(sp)
	lea		8(sp),a6
	move.l	(a6)+,d2
	move.l	(a6)+,d1
	move.l	DOSBase,a6
	jsr		-$2D0(a6)
	tst.l	d0
	sne		d0
	neg.b	d0
	move.b	d0,$10(sp)
	move.l	(sp)+,a6
end;

function Inhibit; xassembler;
asm
	move.l	a6,-(sp)
	lea		8(sp),a6
	move.l	(a6)+,d2
	move.l	(a6)+,d1
	move.l	DOSBase,a6
	jsr		-$2D6(a6)
	tst.l	d0
	sne		d0
	neg.b	d0
	move.b	d0,$10(sp)
	move.l	(sp)+,a6
end;

function AddBuffers; xassembler;
asm
	move.l	a6,-(sp)
	lea		8(sp),a6
	move.l	(a6)+,d2
	move.l	(a6)+,d1
	move.l	DOSBase,a6
	jsr		-$2DC(a6)
	tst.l	d0
	sne		d0
	neg.b	d0
	move.b	d0,$10(sp)
	move.l	(sp)+,a6
end;

function CompareDates; xassembler;
asm
	move.l	a6,-(sp)
	lea		8(sp),a6
	move.l	(a6)+,d2
	move.l	(a6)+,d1
	move.l	DOSBase,a6
	jsr		-$2E2(a6)
	move.l	d0,$10(sp)
	move.l	(sp)+,a6
end;

function DateToStr; xassembler;
asm
	move.l	a6,-(sp)
	move.l	8(sp),d1
	move.l	DOSBase,a6
	jsr		-$2E8(a6)
	tst.l	d0
	sne		d0
	neg.b	d0
	move.b	d0,$C(sp)
	move.l	(sp)+,a6
end;

function StrToDate; xassembler;
asm
	move.l	a6,-(sp)
	move.l	8(sp),d1
	move.l	DOSBase,a6
	jsr		-$2EE(a6)
	tst.l	d0
	sne		d0
	neg.b	d0
	move.b	d0,$C(sp)
	move.l	(sp)+,a6
end;

function InternalLoadSeg; xassembler;
asm
	movem.l	a2/a6,-(sp)
	lea		$C(sp),a6
	move.l	(a6)+,a2
	move.l	(a6)+,a1
	move.l	(a6)+,a0
	move.l	(a6)+,d0
	move.l	DOSBase,a6
	jsr		-$2F4(a6)
	move.l	d0,$1C(sp)
	movem.l	(sp)+,a2/a6
end;

function InternalUnLoadSeg; xassembler;
asm
	move.l	a6,-(sp)
	lea		8(sp),a6
	move.l	(a6)+,a1
	move.l	(a6)+,d1
	move.l	DOSBase,a6
	jsr		-$2FA(a6)
	tst.l	d0
	sne		d0
	neg.b	d0
	move.b	d0,$10(sp)
	move.l	(sp)+,a6
end;

function NewLoadSeg; xassembler;
asm
	move.l	a6,-(sp)
	lea		8(sp),a6
	move.l	(a6)+,d2
	move.l	(a6)+,d1
	move.l	DOSBase,a6
	jsr		-$300(a6)
	move.l	d0,$10(sp)
	move.l	(sp)+,a6
end;

function AddSegment; xassembler;
asm
	movem.l	d3/a6,-(sp)
	lea		$C(sp),a6
	move.l	(a6)+,d3
	move.l	(a6)+,d2
	move.l	(a6)+,d1
	move.l	DOSBase,a6
	jsr		-$306(a6)
	tst.l	d0
	sne		d0
	neg.b	d0
	move.b	d0,$18(sp)
	movem.l	(sp)+,d3/a6
end;

function FindSegment; xassembler;
asm
	movem.l	d3/a6,-(sp)
	lea		$C(sp),a6
	move.l	(a6)+,d3
	move.l	(a6)+,d2
	move.l	(a6)+,d1
	move.l	DOSBase,a6
	jsr		-$30C(a6)
	move.l	d0,$18(sp)
	movem.l	(sp)+,d3/a6
end;

function RemSegment; xassembler;
asm
	move.l	a6,-(sp)
	move.l	8(sp),d1
	move.l	DOSBase,a6
	jsr		-$312(a6)
	tst.l	d0
	sne		d0
	neg.b	d0
	move.b	d0,$C(sp)
	move.l	(sp)+,a6
end;

function CheckSignal; xassembler;
asm
	move.l	a6,-(sp)
	move.l	8(sp),d1
	move.l	DOSBase,a6
	jsr		-$318(a6)
	move.l	d0,$C(sp)
	move.l	(sp)+,a6
end;

function ReadArgs; xassembler;
asm
	movem.l	d3/a6,-(sp)
	lea		$C(sp),a6
	move.l	(a6)+,d3
	move.l	(a6)+,d2
	move.l	(a6)+,d1
	move.l	DOSBase,a6
	jsr		-$31E(a6)
	move.l	d0,$18(sp)
	movem.l	(sp)+,d3/a6
end;

function FindArg; xassembler;
asm
	move.l	a6,-(sp)
	lea		8(sp),a6
	move.l	(a6)+,d2
	move.l	(a6)+,d1
	move.l	DOSBase,a6
	jsr		-$324(a6)
	move.l	d0,$10(sp)
	move.l	(sp)+,a6
end;

function ReadItem; xassembler;
asm
	movem.l	d3/a6,-(sp)
	lea		$C(sp),a6
	move.l	(a6)+,d3
	move.l	(a6)+,d2
	move.l	(a6)+,d1
	move.l	DOSBase,a6
	jsr		-$32A(a6)
	move.l	d0,$18(sp)
	movem.l	(sp)+,d3/a6
end;

function StrToLong; xassembler;
asm
	move.l	a6,-(sp)
	lea		8(sp),a6
	move.l	(a6)+,d2
	move.l	(a6)+,d1
	move.l	DOSBase,a6
	jsr		-$330(a6)
	move.l	d0,$10(sp)
	move.l	(sp)+,a6
end;

function MatchFirst; xassembler;
asm
	move.l	a6,-(sp)
	lea		8(sp),a6
	move.l	(a6)+,d2
	move.l	(a6)+,d1
	move.l	DOSBase,a6
	jsr		-$336(a6)
	move.l	d0,$10(sp)
	move.l	(sp)+,a6
end;

function MatchNext; xassembler;
asm
	move.l	a6,-(sp)
	move.l	8(sp),d1
	move.l	DOSBase,a6
	jsr		-$33C(a6)
	move.l	d0,$C(sp)
	move.l	(sp)+,a6
end;

procedure MatchEnd; xassembler;
asm
	move.l	a6,-(sp)
	move.l	8(sp),d1
	move.l	DOSBase,a6
	jsr		-$342(a6)
	move.l	(sp)+,a6
end;

function ParsePattern; xassembler;
asm
	movem.l	d3/a6,-(sp)
	lea		$C(sp),a6
	move.l	(a6)+,d3
	move.l	(a6)+,d2
	move.l	(a6)+,d1
	move.l	DOSBase,a6
	jsr		-$348(a6)
	move.l	d0,$18(sp)
	movem.l	(sp)+,d3/a6
end;

function MatchPattern; xassembler;
asm
	move.l	a6,-(sp)
	lea		8(sp),a6
	move.l	(a6)+,d2
	move.l	(a6)+,d1
	move.l	DOSBase,a6
	jsr		-$34E(a6)
	tst.l	d0
	sne		d0
	neg.b	d0
	move.b	d0,$10(sp)
	move.l	(sp)+,a6
end;

procedure FreeArgs; xassembler;
asm
	move.l	a6,-(sp)
	move.l	8(sp),d1
	move.l	DOSBase,a6
	jsr		-$35A(a6)
	move.l	(sp)+,a6
end;

function FilePart; xassembler;
asm
	move.l	a6,-(sp)
	move.l	8(sp),d1
	move.l	DOSBase,a6
	jsr		-$366(a6)
	move.l	d0,$C(sp)
	move.l	(sp)+,a6
end;

function PathPart; xassembler;
asm
	move.l	a6,-(sp)
	move.l	8(sp),d1
	move.l	DOSBase,a6
	jsr		-$36C(a6)
	move.l	d0,$C(sp)
	move.l	(sp)+,a6
end;

function AddPart; xassembler;
asm
	movem.l	d3/a6,-(sp)
	lea		$C(sp),a6
	move.l	(a6)+,d3
	move.l	(a6)+,d2
	move.l	(a6)+,d1
	move.l	DOSBase,a6
	jsr		-$372(a6)
	tst.l	d0
	sne		d0
	neg.b	d0
	move.b	d0,$18(sp)
	movem.l	(sp)+,d3/a6
end;

function StartNotify; xassembler;
asm
	move.l	a6,-(sp)
	move.l	8(sp),d1
	move.l	DOSBase,a6
	jsr		-$378(a6)
	tst.l	d0
	sne		d0
	neg.b	d0
	move.b	d0,$C(sp)
	move.l	(sp)+,a6
end;

procedure EndNotify; xassembler;
asm
	move.l	a6,-(sp)
	move.l	8(sp),d1
	move.l	DOSBase,a6
	jsr		-$37E(a6)
	move.l	(sp)+,a6
end;

function SetVar; xassembler;
asm
	movem.l	d3-d4/a6,-(sp)
	lea		$10(sp),a6
	move.l	(a6)+,d4
	move.l	(a6)+,d3
	move.l	(a6)+,d2
	move.l	(a6)+,d1
	move.l	DOSBase,a6
	jsr		-$384(a6)
	tst.l	d0
	sne		d0
	neg.b	d0
	move.b	d0,$20(sp)
	movem.l	(sp)+,d3-d4/a6
end;

function GetVar; xassembler;
asm
	movem.l	d3-d4/a6,-(sp)
	lea		$10(sp),a6
	move.l	(a6)+,d4
	move.l	(a6)+,d3
	move.l	(a6)+,d2
	move.l	(a6)+,d1
	move.l	DOSBase,a6
	jsr		-$38A(a6)
	move.l	d0,$20(sp)
	movem.l	(sp)+,d3-d4/a6
end;

function DeleteVar; xassembler;
asm
	move.l	a6,-(sp)
	lea		8(sp),a6
	move.l	(a6)+,d2
	move.l	(a6)+,d1
	move.l	DOSBase,a6
	jsr		-$390(a6)
	tst.l	d0
	sne		d0
	neg.b	d0
	move.b	d0,$10(sp)
	move.l	(sp)+,a6
end;

function FindVar; xassembler;
asm
	move.l	a6,-(sp)
	lea		8(sp),a6
	move.l	(a6)+,d2
	move.l	(a6)+,d1
	move.l	DOSBase,a6
	jsr		-$396(a6)
	move.l	d0,$10(sp)
	move.l	(sp)+,a6
end;

function CliInitNewcli; xassembler;
asm
	move.l	a6,-(sp)
	move.l	8(sp),a0
	move.l	DOSBase,a6
	jsr		-$3A2(a6)
	move.l	d0,$C(sp)
	move.l	(sp)+,a6
end;

function CliInitRun; xassembler;
asm
	move.l	a6,-(sp)
	move.l	8(sp),a0
	move.l	DOSBase,a6
	jsr		-$3A8(a6)
	move.l	d0,$C(sp)
	move.l	(sp)+,a6
end;

function WriteChars; xassembler;
asm
	move.l	a6,-(sp)
	lea		8(sp),a6
	move.l	(a6)+,d2
	move.l	(a6)+,d1
	move.l	DOSBase,a6
	jsr		-$3AE(a6)
	move.l	d0,$10(sp)
	move.l	(sp)+,a6
end;

function PutStr; xassembler;
asm
	move.l	a6,-(sp)
	move.l	8(sp),d1
	move.l	DOSBase,a6
	jsr		-$3B4(a6)
	move.l	d0,$C(sp)
	move.l	(sp)+,a6
end;

function VPrintf; xassembler;
asm
	move.l	a6,-(sp)
	lea		8(sp),a6
	move.l	(a6)+,d2
	move.l	(a6)+,d1
	move.l	DOSBase,a6
	jsr		-$3BA(a6)
	move.l	d0,$10(sp)
	move.l	(sp)+,a6
end;

function ParsePatternNoCase; xassembler;
asm
	movem.l	d3/a6,-(sp)
	lea		$C(sp),a6
	move.l	(a6)+,d3
	move.l	(a6)+,d2
	move.l	(a6)+,d1
	move.l	DOSBase,a6
	jsr		-$3C6(a6)
	move.l	d0,$18(sp)
	movem.l	(sp)+,d3/a6
end;

function MatchPatternNoCase; xassembler;
asm
	move.l	a6,-(sp)
	lea		8(sp),a6
	move.l	(a6)+,d2
	move.l	(a6)+,d1
	move.l	DOSBase,a6
	jsr		-$3CC(a6)
	tst.l	d0
	sne		d0
	neg.b	d0
	move.b	d0,$10(sp)
	move.l	(sp)+,a6
end;

function SameDevice; xassembler;
asm
	move.l	a6,-(sp)
	lea		8(sp),a6
	move.l	(a6)+,d2
	move.l	(a6)+,d1
	move.l	DOSBase,a6
	jsr		-$3D8(a6)
	tst.l	d0
	sne		d0
	neg.b	d0
	move.b	d0,$10(sp)
	move.l	(sp)+,a6
end;

end.
