unit Graphics_2;

INTERFACE
uses Exec, Graphics, Hardware, Utility;


type
	ppAnimOb = ^pAnimOb;


var
	GfxBase: pGfxBase;


function BltBitMap
		(srcBitMap: pBitMap;
		xSrc: integer;
		ySrc: integer;
		destBitMap: pBitMap;
		xDest: integer;
		yDest: integer;
		xSize: integer;
		ySize: integer;
		minterm: byte;
		mask: byte;
		tempA: PLANEPTR): long;

procedure BltTemplate
		(source: PLANEPTR;
		xSrc: integer;
		srcMod: integer;
		destRP: pRastPort;
		xDest: integer;
		yDest: integer;
		xSize: integer;
		ySize: integer);

procedure ClearEOL (rp: pRastPort);
procedure ClearScreen (rp: pRastPort);
function TextLength
		(rp: pRastPort;
		string_: STRPTR;
		count: integer): integer;

procedure Text_
		(rp: pRastPort;
		string_: STRPTR;
		count: integer);

procedure SetFont
		(rp: pRastPort;
		textFont: pTextFont);

function OpenFont (textAttr: pTextAttr): pTextFont;
procedure CloseFont (textFont: pTextFont);
function AskSoftStyle (rp: pRastPort): long;
function SetSoftStyle
		(rp: pRastPort;
		style: long;
		enable: long): long;

procedure AddBob
		(bob: pBob;
		rp: pRastPort);

procedure AddVSprite
		(vSprite: pVSprite;
		rp: pRastPort);

procedure DoCollision (rp: pRastPort);
procedure DrawGList
		(rp: pRastPort;
		vp: pViewPort);

procedure InitGels
		(head: pVSprite;
		tail: pVSprite;
		gelsInfo: pGelsInfo);

procedure InitMasks (vSprite: pVSprite);
procedure RemIBob
		(bob: pBob;
		rp: pRastPort;
		vp: pViewPort);

procedure RemVSprite (vSprite: pVSprite);
procedure SetCollision
		(num: long;
		routine: pointer;
		gelsInfo: pGelsInfo);

procedure SortGList (rp: pRastPort);
procedure AddAnimOb
		(anOb: pAnimOb;
		anKey: ppAnimOb;
		rp: pRastPort);

procedure Animate
		(anKey: ppAnimOb;
		rp: pRastPort);

function GetGBuffers
		(anOb: pAnimOb;
		rp: pRastPort;
		flag: boolean): boolean;

procedure InitGMasks (anOb: pAnimOb);
procedure DrawEllipse
		(rp: pRastPort;
		xCenter: integer;
		yCenter: integer;
		a: integer;
		b: integer);

function AreaEllipse
		(rp: pRastPort;
		xCenter: integer;
		yCenter: integer;
		a: integer;
		b: integer): longint;

procedure LoadRGB4
		(vp: pViewPort;
		colors: pword;
		count: integer);

procedure InitRastPort (rp: pRastPort);
procedure InitVPort (vp: pViewPort);
procedure MrgCop (view: pView);
procedure MakeVPort
		(view: pView;
		vp: pViewPort);

procedure LoadView (view: pView);
procedure WaitBlit;
procedure SetRast
		(rp: pRastPort;
		pen: byte);

procedure Move_
		(rp: pRastPort;
		x: integer;
		y: integer);

procedure Draw
		(rp: pRastPort;
		x: integer;
		y: integer);

function AreaMove
		(rp: pRastPort;
		x: integer;
		y: integer): longint;

function AreaDraw
		(rp: pRastPort;
		x: integer;
		y: integer): long;

function AreaEnd (rp: pRastPort): longint;
procedure WaitTOF;
procedure QBlit (blit: pbltnode);
procedure InitArea
		(areaInfo: pAreaInfo;
		vectorBuffer: pointer;
		maxVectors: integer);

procedure SetRGB4
		(vp: pViewPort;
		index: integer;
		red: byte;
		green: byte;
		blue: byte);

procedure QBSBlit (blit: pbltnode);
procedure BltClear
		(memBlock: PLANEPTR;
		byteCount: long;
		flags: long);

procedure RectFill
		(rp: pRastPort;
		xMin: integer;
		yMin: integer;
		xMax: integer;
		yMax: integer);

procedure BltPattern
		(rp: pRastPort;
		mask: PLANEPTR;
		xMin: integer;
		yMin: integer;
		xMax: integer;
		yMax: integer;
		maskBPR: integer);

function ReadPixel
		(rp: pRastPort;
		x: integer;
		y: integer): longint;

function WritePixel
		(rp: pRastPort;
		x: integer;
		y: integer): longint;

function Flood
		(rp: pRastPort;
		mode: long;
		x: integer;
		y: integer): boolean;

procedure PolyDraw
		(rp: pRastPort;
		count: integer;
		polyTable: pinteger);

procedure SetAPen
		(rp: pRastPort;
		pen: byte);

procedure SetBPen
		(rp: pRastPort;
		pen: byte);

procedure SetDrMd
		(rp: pRastPort;
		drawMode: byte);

procedure InitView (view: pView);
procedure CBump (copList: pUCopList);
procedure CMove_
		(copList: pUCopList;
		destination: pointer;
		data: integer);

procedure CWait_
		(copList: pUCopList;
		v: integer;
		h: integer);

function VBeamPos: longint;
procedure InitBitMap
		(bitMap: pBitMap;
		depth: shortint;
		width: word;
		height: word);

procedure ScrollRaster
		(rp: pRastPort;
		dx: integer;
		dy: integer;
		xMin: integer;
		yMin: integer;
		xMax: integer;
		yMax: integer);

procedure WaitBOVP (vp: pViewPort);
function GetSprite
		(sprite: pSimpleSprite;
		num: integer): integer;

procedure FreeSprite (num: integer);
procedure ChangeSprite
		(vp: pViewPort;
		sprite: pSimpleSprite;
		newData: PLANEPTR);

procedure MoveSprite
		(vp: pViewPort;
		sprite: pSimpleSprite;
		x: integer;
		y: integer);

procedure LockLayerRom (layer: pLayer);
procedure UnlockLayerRom (layer: pLayer);
procedure SyncSBitMap (layer: pLayer);
procedure CopySBitMap (layer: pLayer);
procedure OwnBlitter;
procedure DisownBlitter;
procedure InitTmpRas
		(tmpRas: pTmpRas;
		buffer: PLANEPTR;
		size: long);

procedure AskFont
		(rp: pRastPort;
		textAttr: pTextAttr);

procedure AddFont (textFont: pTextFont);
procedure RemFont (textFont: pTextFont);
function AllocRaster
		(width: word;
		height: word): PLANEPTR;

procedure FreeRaster
		(p: PLANEPTR;
		width: word;
		height: word);

procedure AndRectRegion
		(region: pRegion;
		rectangle: pRectangle);

function OrRectRegion
		(region: pRegion;
		rectangle: pRectangle): boolean;

function NewRegion: pRegion;
function ClearRectRegion
		(region: pRegion;
		rectangle: pRectangle): boolean;

procedure ClearRegion (region: pRegion);
procedure DisposeRegion (region: pRegion);
procedure FreeVPortCopLists (vp: pViewPort);
procedure FreeCopList (copList: pCopList);
procedure ClipBlit
		(srcRP: pRastPort;
		xSrc: integer;
		ySrc: integer;
		destRP: pRastPort;
		xDest: integer;
		yDest: integer;
		xSize: integer;
		ySize: integer;
		minterm: byte);

function XorRectRegion
		(region: pRegion;
		rectangle: pRectangle): boolean;

procedure FreeCprList (cprList: pcprlist);
function GetColorMap (entries: long): pColorMap;
procedure FreeColorMap (colorMap: pColorMap);
function GetRGB4
		(colorMap: pColorMap;
		entry: longint): long;

procedure ScrollVPort (vp: pViewPort);
function UCopperListInit
		(uCopList: pUCopList;
		n: word): pCopList;

procedure FreeGBuffers
		(anOb: pAnimOb;
		rp: pRastPort;
		flag: boolean);

function BltBitMapRastPort
		(srcBitMap: pBitMap;
		xSrc: integer;
		ySrc: integer;
		destRP: pRastPort;
		xDest: integer;
		yDest: integer;
		xSize: integer;
		ySize: integer;
		minterm: byte): boolean;

function OrRegionRegion
		(srcRegion: pRegion;
		destRegion: pRegion): boolean;

function XorRegionRegion
		(srcRegion: pRegion;
		destRegion: pRegion): boolean;

function AndRegionRegion
		(srcRegion: pRegion;
		destRegion: pRegion): boolean;

procedure SetRGB4CM
		(colorMap: pColorMap;
		index: integer;
		red: byte;
		green: byte;
		blue: byte);

procedure BltMaskBitMapRastPort
		(srcBitMap: pBitMap;
		xSrc: integer;
		ySrc: integer;
		destRP: pRastPort;
		xDest: integer;
		yDest: integer;
		xSize: integer;
		ySize: integer;
		minterm: byte;
		bltMask: PLANEPTR);

function AttemptLockLayerRom (layer: pLayer): boolean;
function GfxNew (gfxNodeType: long): pExtendedNode;
procedure GfxFree (gfxNodePtr: pExtendedNode);
procedure GfxAssociate
		(associateNode: pointer;
		gfxNodePtr: pExtendedNode);

procedure BitMapScale (bitScaleArgs: pBitScaleArgs);
function ScalerDiv
		(factor: word;
		numerator: word;
		denominator: word): word;

procedure TextExtent
		(rp: pRastPort;
		string_: STRPTR;
		count: integer;
		textExtent: pTextExtent);

function TextFit
		(rp: pRastPort;
		string_: STRPTR;
		strLen: word;
		textExtent: pTextExtent;
		constrainingExtent: pTextExtent;
		strDirection: integer;
		constrainingBitWidth: word;
		constrainingBitHeight: word): long;

function GfxLookUp (associateNode: pointer): pExtendedNode;
function VideoControl
		(colorMap: pColorMap;
		tagarray: pTagItem): long;

function OpenMonitor
		(monitorName: STRPTR;
		displayID: long): pMonitorSpec;

function CloseMonitor (monitorSpec: pMonitorSpec): longint;
function FindDisplayInfo (displayID: long): DisplayInfoHandle;
function NextDisplayInfo (displayID: long): long;
function GetDisplayInfoData
		(handle: DisplayInfoHandle;
		buf: pbyte;
		size: long;
		tagID: long;
		displayID: long): long;

procedure FontExtent
		(font: pTextFont;
		fontExtent: pTextExtent);

function ReadPixelLine8
		(rp: pRastPort;
		xstart: word;
		ystart: word;
		width: word;
		array_: pbyte;
		tempRP: pRastPort): longint;

function WritePixelLine8
		(rp: pRastPort;
		xstart: word;
		ystart: word;
		width: word;
		array_: pbyte;
		tempRP: pRastPort): longint;

function ReadPixelArray8
		(rp: pRastPort;
		xstart: word;
		ystart: word;
		xstop: word;
		ystop: word;
		array_: pbyte;
		temprp: pRastPort): longint;

function WritePixelArray8
		(rp: pRastPort;
		xstart: word;
		ystart: word;
		xstop: word;
		ystop: word;
		array_: pbyte;
		temprp: pRastPort): longint;

function GetVPModeID (vp: pViewPort): long;
function ModeNotAvailable (modeID: long): long;
function WeighTAMatch
		(reqTextAttr: pTTextAttr;
		targetTextAttr: pTextAttr;
		targetTags: pTagItem): integer;

procedure EraseRect
		(rp: pRastPort;
		xMin: integer;
		yMin: integer;
		xMax: integer;
		yMax: integer);

function ExtendFont
		(font: pTextFont;
		fontTags: pTagItem): long;

procedure StripFont (font: pTextFont);


function AreaCircle
			(rastPort: pRastPort;
			cx: integer;
			cy: integer;
			r: integer): longint;

procedure DrawCircle
			(rastPort: pRastPort;
			cx: integer;
			cy: integer;
			r: integer);

procedure SetOPen
			(w: pRastPort;
			c: shortint);

procedure SetWrMsk
			(w: pRastPort;
			m: Byte);

procedure SetDrPt
			(w: pRastPort;
			p: word);

procedure SetAfPt
			(w: pRastPort;
			p: pWord;
			n: shortint);

function RASSIZE
			(w: integer;
			h: integer): longint;

procedure CINIT
			(copperlist: pUCopList;
			num: word);

procedure CMOVE
			(copperList: pUCopList;
			var destination: pointer;
			data: integer);

procedure CWAIT
			(copperList: pUCopList;
			x: integer;
			y: integer);

procedure CEND (copperList: pUCopList);
procedure BNDRYOFF (w: pRastPort);
procedure OFF_DISPLAY (custom: pCustom);
procedure ON_DISPLAY (custom: pCustom);
procedure OFF_SPRITE (custom: pCustom);
procedure ON_SPRITE (custom: pCustom);
procedure OFF_VBLANK (custom: pCustom);
procedure ON_VBLANK (custom: pCustom);
procedure InitAnimate (animkey: ppAnimOb);
procedure RemBob (bob: pBob);


IMPLEMENTATION
procedure BNDRYOFF;
begin
	with w^ do
		Flags := Flags and (not AREAOUTLINE)
end;

procedure InitAnimate;
begin
	animkey^ := NIL
end;

procedure RemBob;
begin
	with bob^ do
		Flags := Flags or BOBSAWAY
end;

procedure SetAfPt;
begin
	with w^ do
	begin
		AreaPtrn := p;
		AreaPtSz := n
	end
end;

procedure SetDrPt;
begin
	with w^ do
	begin
		LinePtrn	:= p;
		Flags		:= Flags or FRST_DOT;
		linpatcnt	:= 15
	end
end;

procedure SetOPen;
begin
	with w^ do
	begin
		AOlPen	:= c;
		Flags	:= Flags or AREAOUTLINE
	end
end;

procedure SetWrMsk;
begin
	w^.Mask := m
end;

procedure OFF_DISPLAY;
begin
	custom^.dmacon := BITCLR or DMAF_RASTER
end;

procedure ON_DISPLAY;
begin
	custom^.dmacon := BITSET or DMAF_RASTER
end;

procedure OFF_SPRITE;
begin
	custom^.dmacon := BITCLR or DMAF_SPRITE
end;

procedure ON_SPRITE;
begin
	custom^.dmacon := BITSET or DMAF_SPRITE
end;

procedure OFF_VBLANK;
begin
	custom^.intena := BITCLR or INTF_VERTB
end;

procedure ON_VBLANK;
begin
	custom^.intena := BITSET or INTF_VERTB
end;

function AreaCircle;
begin
	AreaCircle := AreaEllipse(rastPort, cx, cy, r, r)
end;

procedure DrawCircle;
begin
	DrawEllipse(rastPort, cx, cy, r, r)
end;

function RASSIZE;
var
	result: Longint;
begin
	result := ((w + 15) shr 3) and $FFFE;
	RASSIZE := h * result
end;

procedure CINIT;
var
	junk: pCopList;
begin
	junk := UCopperListInit(copperlist,num)
end;

procedure CMOVE;
begin
	CMove_(copperList, @destination, data);
	CBump(copperList)
end;

procedure CWAIT;
begin
	CWait_(copperList, x, y);
	CBump(copperList)
end;
	
procedure CEND;
begin
	CWAIT(copperlist, 10000, 255)
end;

function BltBitMap; xassembler;
asm
	movem.l	d3-d7/a2/a6,-(sp)
	lea		$20(sp),a6
	move.l	(a6)+,a2
	move.b	(a6)+,d7
	addq.l	#1,a6
	move.b	(a6)+,d6
	addq.l	#1,a6
	move.w	(a6)+,d5
	move.w	(a6)+,d4
	move.w	(a6)+,d3
	move.w	(a6)+,d2
	move.l	(a6)+,a1
	move.w	(a6)+,d1
	move.w	(a6)+,d0
	move.l	(a6)+,a0
	move.l	GfxBase,a6
	jsr		-$1E(a6)
	move.l	d0,$3C(sp)
	movem.l	(sp)+,d3-d7/a2/a6
end;

procedure BltTemplate; xassembler;
asm
	movem.l	d3-d5/a6,-(sp)
	lea		$14(sp),a6
	move.w	(a6)+,d5
	move.w	(a6)+,d4
	move.w	(a6)+,d3
	move.w	(a6)+,d2
	move.l	(a6)+,a1
	move.w	(a6)+,d1
	move.w	(a6)+,d0
	move.l	(a6)+,a0
	move.l	GfxBase,a6
	jsr		-$24(a6)
	movem.l	(sp)+,d3-d5/a6
end;

procedure ClearEOL; xassembler;
asm
	move.l	a6,-(sp)
	move.l	8(sp),a1
	move.l	GfxBase,a6
	jsr		-$2A(a6)
	move.l	(sp)+,a6
end;

procedure ClearScreen; xassembler;
asm
	move.l	a6,-(sp)
	move.l	8(sp),a1
	move.l	GfxBase,a6
	jsr		-$30(a6)
	move.l	(sp)+,a6
end;

function TextLength; xassembler;
asm
	move.l	a6,-(sp)
	lea		8(sp),a6
	move.w	(a6)+,d0
	move.l	(a6)+,a0
	move.l	(a6)+,a1
	move.l	GfxBase,a6
	jsr		-$36(a6)
	move.w	d0,$12(sp)
	move.l	(sp)+,a6
end;

procedure Text_; xassembler;
asm
	move.l	a6,-(sp)
	lea		8(sp),a6
	move.w	(a6)+,d0
	move.l	(a6)+,a0
	move.l	(a6)+,a1
	move.l	GfxBase,a6
	jsr		-$3C(a6)
	move.l	(sp)+,a6
end;

procedure SetFont; xassembler;
asm
	move.l	a6,-(sp)
	movem.l	8(sp),a0-a1
	move.l	GfxBase,a6
	jsr		-$42(a6)
	move.l	(sp)+,a6
end;

function OpenFont; xassembler;
asm
	move.l	a6,-(sp)
	move.l	8(sp),a0
	move.l	GfxBase,a6
	jsr		-$48(a6)
	move.l	d0,$C(sp)
	move.l	(sp)+,a6
end;

procedure CloseFont; xassembler;
asm
	move.l	a6,-(sp)
	move.l	8(sp),a1
	move.l	GfxBase,a6
	jsr		-$4E(a6)
	move.l	(sp)+,a6
end;

function AskSoftStyle; xassembler;
asm
	move.l	a6,-(sp)
	move.l	8(sp),a1
	move.l	GfxBase,a6
	jsr		-$54(a6)
	move.l	d0,$C(sp)
	move.l	(sp)+,a6
end;

function SetSoftStyle; xassembler;
asm
	move.l	a6,-(sp)
	lea		8(sp),a6
	move.l	(a6)+,d1
	move.l	(a6)+,d0
	move.l	(a6)+,a1
	move.l	GfxBase,a6
	jsr		-$5A(a6)
	move.l	d0,$14(sp)
	move.l	(sp)+,a6
end;

procedure AddBob; xassembler;
asm
	move.l	a6,-(sp)
	lea		8(sp),a6
	move.l	(a6)+,a1
	move.l	(a6)+,a0
	move.l	GfxBase,a6
	jsr		-$60(a6)
	move.l	(sp)+,a6
end;

procedure AddVSprite; xassembler;
asm
	move.l	a6,-(sp)
	lea		8(sp),a6
	move.l	(a6)+,a1
	move.l	(a6)+,a0
	move.l	GfxBase,a6
	jsr		-$66(a6)
	move.l	(sp)+,a6
end;

procedure DoCollision; xassembler;
asm
	move.l	a6,-(sp)
	move.l	8(sp),a1
	move.l	GfxBase,a6
	jsr		-$6C(a6)
	move.l	(sp)+,a6
end;

procedure DrawGList; xassembler;
asm
	move.l	a6,-(sp)
	movem.l	8(sp),a0-a1
	move.l	GfxBase,a6
	jsr		-$72(a6)
	move.l	(sp)+,a6
end;

procedure InitGels; xassembler;
asm
	movem.l	a2/a6,-(sp)
	lea		$C(sp),a6
	move.l	(a6)+,a2
	move.l	(a6)+,a1
	move.l	(a6)+,a0
	move.l	GfxBase,a6
	jsr		-$78(a6)
	movem.l	(sp)+,a2/a6
end;

procedure InitMasks; xassembler;
asm
	move.l	a6,-(sp)
	move.l	8(sp),a0
	move.l	GfxBase,a6
	jsr		-$7E(a6)
	move.l	(sp)+,a6
end;

procedure RemIBob; xassembler;
asm
	movem.l	a2/a6,-(sp)
	lea		$C(sp),a6
	move.l	(a6)+,a2
	move.l	(a6)+,a1
	move.l	(a6)+,a0
	move.l	GfxBase,a6
	jsr		-$84(a6)
	movem.l	(sp)+,a2/a6
end;

procedure RemVSprite; xassembler;
asm
	move.l	a6,-(sp)
	move.l	8(sp),a0
	move.l	GfxBase,a6
	jsr		-$8A(a6)
	move.l	(sp)+,a6
end;

procedure SetCollision; xassembler;
asm
	move.l	a6,-(sp)
	lea		8(sp),a6
	move.l	(a6)+,a1
	move.l	(a6)+,a0
	move.l	(a6)+,d0
	move.l	GfxBase,a6
	jsr		-$90(a6)
	move.l	(sp)+,a6
end;

procedure SortGList; xassembler;
asm
	move.l	a6,-(sp)
	move.l	8(sp),a1
	move.l	GfxBase,a6
	jsr		-$96(a6)
	move.l	(sp)+,a6
end;

procedure AddAnimOb; xassembler;
asm
	movem.l	a2/a6,-(sp)
	lea		$C(sp),a6
	move.l	(a6)+,a2
	move.l	(a6)+,a1
	move.l	(a6)+,a0
	move.l	GfxBase,a6
	jsr		-$9C(a6)
	movem.l	(sp)+,a2/a6
end;

procedure Animate; xassembler;
asm
	move.l	a6,-(sp)
	lea		8(sp),a6
	move.l	(a6)+,a1
	move.l	(a6)+,a0
	move.l	GfxBase,a6
	jsr		-$A2(a6)
	move.l	(sp)+,a6
end;

function GetGBuffers; xassembler;
asm
	move.l	a6,-(sp)
	moveq	#0,d0
	lea		8(sp),a6
	move.b	(a6)+,d0
	addq.l	#1,a6
	move.l	(a6)+,a1
	move.l	(a6)+,a0
	move.l	GfxBase,a6
	jsr		-$A8(a6)
	tst.l	d0
	sne		d0
	neg.b	d0
	move.b	d0,$12(sp)
	move.l	(sp)+,a6
end;

procedure InitGMasks; xassembler;
asm
	move.l	a6,-(sp)
	move.l	8(sp),a0
	move.l	GfxBase,a6
	jsr		-$AE(a6)
	move.l	(sp)+,a6
end;

procedure DrawEllipse; xassembler;
asm
	movem.l	d3/a6,-(sp)
	lea		$C(sp),a6
	move.w	(a6)+,d3
	move.w	(a6)+,d2
	move.w	(a6)+,d1
	move.w	(a6)+,d0
	move.l	(a6)+,a1
	move.l	GfxBase,a6
	jsr		-$B4(a6)
	movem.l	(sp)+,d3/a6
end;

function AreaEllipse; xassembler;
asm
	movem.l	d3/a6,-(sp)
	lea		$C(sp),a6
	move.w	(a6)+,d3
	move.w	(a6)+,d2
	move.w	(a6)+,d1
	move.w	(a6)+,d0
	move.l	(a6)+,a1
	move.l	GfxBase,a6
	jsr		-$BA(a6)
	move.l	d0,$18(sp)
	movem.l	(sp)+,d3/a6
end;

procedure LoadRGB4; xassembler;
asm
	move.l	a6,-(sp)
	lea		8(sp),a6
	move.w	(a6)+,d0
	move.l	(a6)+,a1
	move.l	(a6)+,a0
	move.l	GfxBase,a6
	jsr		-$C0(a6)
	move.l	(sp)+,a6
end;

procedure InitRastPort; xassembler;
asm
	move.l	a6,-(sp)
	move.l	8(sp),a1
	move.l	GfxBase,a6
	jsr		-$C6(a6)
	move.l	(sp)+,a6
end;

procedure InitVPort; xassembler;
asm
	move.l	a6,-(sp)
	move.l	8(sp),a0
	move.l	GfxBase,a6
	jsr		-$CC(a6)
	move.l	(sp)+,a6
end;

procedure MrgCop; xassembler;
asm
	move.l	a6,-(sp)
	move.l	8(sp),a1
	move.l	GfxBase,a6
	jsr		-$D2(a6)
	move.l	(sp)+,a6
end;

procedure MakeVPort; xassembler;
asm
	move.l	a6,-(sp)
	lea		8(sp),a6
	move.l	(a6)+,a1
	move.l	(a6)+,a0
	move.l	GfxBase,a6
	jsr		-$D8(a6)
	move.l	(sp)+,a6
end;

procedure LoadView; xassembler;
asm
	move.l	a6,-(sp)
	move.l	8(sp),a1
	move.l	GfxBase,a6
	jsr		-$DE(a6)
	move.l	(sp)+,a6
end;

procedure WaitBlit; xassembler;
asm
	move.l	a6,-(sp)
	move.l	GfxBase,a6
	jsr		-$E4(a6)
	move.l	(sp)+,a6
end;

procedure SetRast; xassembler;
asm
	move.l	a6,-(sp)
	move.b	8(sp),d0
	move.l	$A(sp),a1
	move.l	GfxBase,a6
	jsr		-$EA(a6)
	move.l	(sp)+,a6
end;

procedure Move_; xassembler;
asm
	move.l	a6,-(sp)
	lea		8(sp),a6
	move.w	(a6)+,d1
	move.w	(a6)+,d0
	move.l	(a6)+,a1
	move.l	GfxBase,a6
	jsr		-$F0(a6)
	move.l	(sp)+,a6
end;

procedure Draw; xassembler;
asm
	move.l	a6,-(sp)
	lea		8(sp),a6
	move.w	(a6)+,d1
	move.w	(a6)+,d0
	move.l	(a6)+,a1
	move.l	GfxBase,a6
	jsr		-$F6(a6)
	move.l	(sp)+,a6
end;

function AreaMove; xassembler;
asm
	move.l	a6,-(sp)
	lea		8(sp),a6
	move.w	(a6)+,d1
	move.w	(a6)+,d0
	move.l	(a6)+,a1
	move.l	GfxBase,a6
	jsr		-$FC(a6)
	move.l	d0,$10(sp)
	move.l	(sp)+,a6
end;

function AreaDraw; xassembler;
asm
	move.l	a6,-(sp)
	lea		8(sp),a6
	move.w	(a6)+,d1
	move.w	(a6)+,d0
	move.l	(a6)+,a1
	move.l	GfxBase,a6
	jsr		-$102(a6)
	move.l	d0,$10(sp)
	move.l	(sp)+,a6
end;

function AreaEnd; xassembler;
asm
	move.l	a6,-(sp)
	move.l	8(sp),a1
	move.l	GfxBase,a6
	jsr		-$108(a6)
	move.l	d0,$C(sp)
	move.l	(sp)+,a6
end;

procedure WaitTOF; xassembler;
asm
	move.l	a6,-(sp)
	move.l	GfxBase,a6
	jsr		-$10E(a6)
	move.l	(sp)+,a6
end;

procedure QBlit; xassembler;
asm
	move.l	a6,-(sp)
	move.l	8(sp),a1
	move.l	GfxBase,a6
	jsr		-$114(a6)
	move.l	(sp)+,a6
end;

procedure InitArea; xassembler;
asm
	move.l	a6,-(sp)
	lea		8(sp),a6
	move.w	(a6)+,d0
	move.l	(a6)+,a1
	move.l	(a6)+,a0
	move.l	GfxBase,a6
	jsr		-$11A(a6)
	move.l	(sp)+,a6
end;

procedure SetRGB4; xassembler;
asm
	movem.l	d3/a6,-(sp)
	lea		$C(sp),a6
	move.b	(a6)+,d3
	addq.l	#1,a6
	move.b	(a6)+,d2
	addq.l	#1,a6
	move.b	(a6)+,d1
	addq.l	#1,a6
	move.w	(a6)+,d0
	move.l	(a6)+,a0
	move.l	GfxBase,a6
	jsr		-$120(a6)
	movem.l	(sp)+,d3/a6
end;

procedure QBSBlit; xassembler;
asm
	move.l	a6,-(sp)
	move.l	8(sp),a1
	move.l	GfxBase,a6
	jsr		-$126(a6)
	move.l	(sp)+,a6
end;

procedure BltClear; xassembler;
asm
	move.l	a6,-(sp)
	lea		8(sp),a6
	move.l	(a6)+,d1
	move.l	(a6)+,d0
	move.l	(a6)+,a1
	move.l	GfxBase,a6
	jsr		-$12C(a6)
	move.l	(sp)+,a6
end;

procedure RectFill; xassembler;
asm
	movem.l	d3/a6,-(sp)
	lea		$C(sp),a6
	move.w	(a6)+,d3
	move.w	(a6)+,d2
	move.w	(a6)+,d1
	move.w	(a6)+,d0
	move.l	(a6)+,a1
	move.l	GfxBase,a6
	jsr		-$132(a6)
	movem.l	(sp)+,d3/a6
end;

procedure BltPattern; xassembler;
asm
	movem.l	d3-d4/a6,-(sp)
	lea		$10(sp),a6
	move.w	(a6)+,d4
	move.w	(a6)+,d3
	move.w	(a6)+,d2
	move.w	(a6)+,d1
	move.w	(a6)+,d0
	move.l	(a6)+,a0
	move.l	(a6)+,a1
	move.l	GfxBase,a6
	jsr		-$138(a6)
	movem.l	(sp)+,d3-d4/a6
end;

function ReadPixel; xassembler;
asm
	move.l	a6,-(sp)
	lea		8(sp),a6
	move.w	(a6)+,d1
	move.w	(a6)+,d0
	move.l	(a6)+,a1
	move.l	GfxBase,a6
	jsr		-$13E(a6)
	move.l	d0,$10(sp)
	move.l	(sp)+,a6
end;

function WritePixel; xassembler;
asm
	move.l	a6,-(sp)
	lea		8(sp),a6
	move.w	(a6)+,d1
	move.w	(a6)+,d0
	move.l	(a6)+,a1
	move.l	GfxBase,a6
	jsr		-$144(a6)
	move.l	d0,$10(sp)
	move.l	(sp)+,a6
end;

function Flood; xassembler;
asm
	move.l	a6,-(sp)
	lea		8(sp),a6
	move.w	(a6)+,d1
	move.w	(a6)+,d0
	move.l	(a6)+,d2
	move.l	(a6)+,a1
	move.l	GfxBase,a6
	jsr		-$14A(a6)
	tst.l	d0
	sne		d0
	neg.b	d0
	move.b	d0,$14(sp)
	move.l	(sp)+,a6
end;

procedure PolyDraw; xassembler;
asm
	move.l	a6,-(sp)
	lea		8(sp),a6
	move.l	(a6)+,a0
	move.w	(a6)+,d0
	move.l	(a6)+,a1
	move.l	GfxBase,a6
	jsr		-$150(a6)
	move.l	(sp)+,a6
end;

procedure SetAPen; xassembler;
asm
	move.l	a6,-(sp)
	move.b	8(sp),d0
	move.l	$A(sp),a1
	move.l	GfxBase,a6
	jsr		-$156(a6)
	move.l	(sp)+,a6
end;

procedure SetBPen; xassembler;
asm
	move.l	a6,-(sp)
	move.b	8(sp),d0
	move.l	$A(sp),a1
	move.l	GfxBase,a6
	jsr		-$15C(a6)
	move.l	(sp)+,a6
end;

procedure SetDrMd; xassembler;
asm
	move.l	a6,-(sp)
	move.b	8(sp),d0
	move.l	$A(sp),a1
	move.l	GfxBase,a6
	jsr		-$162(a6)
	move.l	(sp)+,a6
end;

procedure InitView; xassembler;
asm
	move.l	a6,-(sp)
	move.l	8(sp),a1
	move.l	GfxBase,a6
	jsr		-$168(a6)
	move.l	(sp)+,a6
end;

procedure CBump; xassembler;
asm
	move.l	a6,-(sp)
	move.l	8(sp),a1
	move.l	GfxBase,a6
	jsr		-$16E(a6)
	move.l	(sp)+,a6
end;

procedure CMove_; xassembler;
asm
	move.l	a6,-(sp)
	lea		8(sp),a6
	move.w	(a6)+,d1
	move.l	(a6)+,d0
	move.l	(a6)+,a1
	move.l	GfxBase,a6
	jsr		-$174(a6)
	move.l	(sp)+,a6
end;

procedure CWait_; xassembler;
asm
	move.l	a6,-(sp)
	lea		8(sp),a6
	move.w	(a6)+,d1
	move.w	(a6)+,d0
	move.l	(a6)+,a1
	move.l	GfxBase,a6
	jsr		-$17A(a6)
	move.l	(sp)+,a6
end;

function VBeamPos; xassembler;
asm
	move.l	a6,-(sp)
	move.l	GfxBase,a6
	jsr		-$180(a6)
	move.l	d0,8(sp)
	move.l	(sp)+,a6
end;

procedure InitBitMap; xassembler;
asm
	move.l	a6,-(sp)
	lea		8(sp),a6
	move.w	(a6)+,d2
	move.w	(a6)+,d1
	move.b	(a6)+,d0
	addq.l	#1,a6
	move.l	(a6)+,a0
	move.l	GfxBase,a6
	jsr		-$186(a6)
	move.l	(sp)+,a6
end;

procedure ScrollRaster; xassembler;
asm
	movem.l	d3-d5/a6,-(sp)
	lea		$14(sp),a6
	move.w	(a6)+,d5
	move.w	(a6)+,d4
	move.w	(a6)+,d3
	move.w	(a6)+,d2
	move.w	(a6)+,d1
	move.w	(a6)+,d0
	move.l	(a6)+,a1
	move.l	GfxBase,a6
	jsr		-$18C(a6)
	movem.l	(sp)+,d3-d5/a6
end;

procedure WaitBOVP; xassembler;
asm
	move.l	a6,-(sp)
	move.l	8(sp),a0
	move.l	GfxBase,a6
	jsr		-$192(a6)
	move.l	(sp)+,a6
end;

function GetSprite; xassembler;
asm
	move.l	a6,-(sp)
	lea		8(sp),a6
	move.w	(a6)+,d0
	move.l	(a6)+,a0
	move.l	GfxBase,a6
	jsr		-$198(a6)
	move.w	d0,$E(sp)
	move.l	(sp)+,a6
end;

procedure FreeSprite; xassembler;
asm
	move.l	a6,-(sp)
	move.w	8(sp),d0
	move.l	GfxBase,a6
	jsr		-$19E(a6)
	move.l	(sp)+,a6
end;

procedure ChangeSprite; xassembler;
asm
	movem.l	a2/a6,-(sp)
	lea		$C(sp),a6
	move.l	(a6)+,a2
	move.l	(a6)+,a1
	move.l	(a6)+,a0
	move.l	GfxBase,a6
	jsr		-$1A4(a6)
	movem.l	(sp)+,a2/a6
end;

procedure MoveSprite; xassembler;
asm
	move.l	a6,-(sp)
	lea		8(sp),a6
	move.w	(a6)+,d1
	move.w	(a6)+,d0
	move.l	(a6)+,a1
	move.l	(a6)+,a0
	move.l	GfxBase,a6
	jsr		-$1AA(a6)
	move.l	(sp)+,a6
end;

procedure LockLayerRom; xassembler;
asm
	movem.l	a5-a6,-(sp)
	move.l	$C(sp),a5
	move.l	GfxBase,a6
	jsr		-$1B0(a6)
	movem.l	(sp)+,a5-a6
end;

procedure UnlockLayerRom; xassembler;
asm
	movem.l	a5-a6,-(sp)
	move.l	$C(sp),a5
	move.l	GfxBase,a6
	jsr		-$1B6(a6)
	movem.l	(sp)+,a5-a6
end;

procedure SyncSBitMap; xassembler;
asm
	move.l	a6,-(sp)
	move.l	8(sp),a0
	move.l	GfxBase,a6
	jsr		-$1BC(a6)
	move.l	(sp)+,a6
end;

procedure CopySBitMap; xassembler;
asm
	move.l	a6,-(sp)
	move.l	8(sp),a0
	move.l	GfxBase,a6
	jsr		-$1C2(a6)
	move.l	(sp)+,a6
end;

procedure OwnBlitter; xassembler;
asm
	move.l	a6,-(sp)
	move.l	GfxBase,a6
	jsr		-$1C8(a6)
	move.l	(sp)+,a6
end;

procedure DisownBlitter; xassembler;
asm
	move.l	a6,-(sp)
	move.l	GfxBase,a6
	jsr		-$1CE(a6)
	move.l	(sp)+,a6
end;

procedure InitTmpRas; xassembler;
asm
	move.l	a6,-(sp)
	lea		8(sp),a6
	move.l	(a6)+,d0
	move.l	(a6)+,a1
	move.l	(a6)+,a0
	move.l	GfxBase,a6
	jsr		-$1D4(a6)
	move.l	(sp)+,a6
end;

procedure AskFont; xassembler;
asm
	move.l	a6,-(sp)
	movem.l	8(sp),a0-a1
	move.l	GfxBase,a6
	jsr		-$1DA(a6)
	move.l	(sp)+,a6
end;

procedure AddFont; xassembler;
asm
	move.l	a6,-(sp)
	move.l	8(sp),a1
	move.l	GfxBase,a6
	jsr		-$1E0(a6)
	move.l	(sp)+,a6
end;

procedure RemFont; xassembler;
asm
	move.l	a6,-(sp)
	move.l	8(sp),a1
	move.l	GfxBase,a6
	jsr		-$1E6(a6)
	move.l	(sp)+,a6
end;

function AllocRaster; xassembler;
asm
	move.l	a6,-(sp)
	lea		8(sp),a6
	move.w	(a6)+,d1
	move.w	(a6)+,d0
	move.l	GfxBase,a6
	jsr		-$1EC(a6)
	move.l	d0,$C(sp)
	move.l	(sp)+,a6
end;

procedure FreeRaster; xassembler;
asm
	move.l	a6,-(sp)
	lea		8(sp),a6
	move.w	(a6)+,d1
	move.w	(a6)+,d0
	move.l	(a6)+,a0
	move.l	GfxBase,a6
	jsr		-$1F2(a6)
	move.l	(sp)+,a6
end;

procedure AndRectRegion; xassembler;
asm
	move.l	a6,-(sp)
	lea		8(sp),a6
	move.l	(a6)+,a1
	move.l	(a6)+,a0
	move.l	GfxBase,a6
	jsr		-$1F8(a6)
	move.l	(sp)+,a6
end;

function OrRectRegion; xassembler;
asm
	move.l	a6,-(sp)
	lea		8(sp),a6
	move.l	(a6)+,a1
	move.l	(a6)+,a0
	move.l	GfxBase,a6
	jsr		-$1FE(a6)
	tst.l	d0
	sne		d0
	neg.b	d0
	move.b	d0,$10(sp)
	move.l	(sp)+,a6
end;

function NewRegion; xassembler;
asm
	move.l	a6,-(sp)
	move.l	GfxBase,a6
	jsr		-$204(a6)
	move.l	d0,8(sp)
	move.l	(sp)+,a6
end;

function ClearRectRegion; xassembler;
asm
	move.l	a6,-(sp)
	lea		8(sp),a6
	move.l	(a6)+,a1
	move.l	(a6)+,a0
	move.l	GfxBase,a6
	jsr		-$20A(a6)
	tst.l	d0
	sne		d0
	neg.b	d0
	move.b	d0,$10(sp)
	move.l	(sp)+,a6
end;

procedure ClearRegion; xassembler;
asm
	move.l	a6,-(sp)
	move.l	8(sp),a0
	move.l	GfxBase,a6
	jsr		-$210(a6)
	move.l	(sp)+,a6
end;

procedure DisposeRegion; xassembler;
asm
	move.l	a6,-(sp)
	move.l	8(sp),a0
	move.l	GfxBase,a6
	jsr		-$216(a6)
	move.l	(sp)+,a6
end;

procedure FreeVPortCopLists; xassembler;
asm
	move.l	a6,-(sp)
	move.l	8(sp),a0
	move.l	GfxBase,a6
	jsr		-$21C(a6)
	move.l	(sp)+,a6
end;

procedure FreeCopList; xassembler;
asm
	move.l	a6,-(sp)
	move.l	8(sp),a0
	move.l	GfxBase,a6
	jsr		-$222(a6)
	move.l	(sp)+,a6
end;

procedure ClipBlit; xassembler;
asm
	movem.l	d3-d6/a6,-(sp)
	lea		$18(sp),a6
	move.b	(a6)+,d6
	addq.l	#1,a6
	move.w	(a6)+,d5
	move.w	(a6)+,d4
	move.w	(a6)+,d3
	move.w	(a6)+,d2
	move.l	(a6)+,a1
	move.w	(a6)+,d1
	move.w	(a6)+,d0
	move.l	(a6)+,a0
	move.l	GfxBase,a6
	jsr		-$228(a6)
	movem.l	(sp)+,d3-d6/a6
end;

function XorRectRegion; xassembler;
asm
	move.l	a6,-(sp)
	lea		8(sp),a6
	move.l	(a6)+,a1
	move.l	(a6)+,a0
	move.l	GfxBase,a6
	jsr		-$22E(a6)
	tst.l	d0
	sne		d0
	neg.b	d0
	move.b	d0,$10(sp)
	move.l	(sp)+,a6
end;

procedure FreeCprList; xassembler;
asm
	move.l	a6,-(sp)
	move.l	8(sp),a0
	move.l	GfxBase,a6
	jsr		-$234(a6)
	move.l	(sp)+,a6
end;

function GetColorMap; xassembler;
asm
	move.l	a6,-(sp)
	move.l	8(sp),d0
	move.l	GfxBase,a6
	jsr		-$23A(a6)
	move.l	d0,$C(sp)
	move.l	(sp)+,a6
end;

procedure FreeColorMap; xassembler;
asm
	move.l	a6,-(sp)
	move.l	8(sp),a0
	move.l	GfxBase,a6
	jsr		-$240(a6)
	move.l	(sp)+,a6
end;

function GetRGB4; xassembler;
asm
	move.l	a6,-(sp)
	movem.l	8(sp),d0/a0
	move.l	GfxBase,a6
	jsr		-$246(a6)
	move.l	d0,$10(sp)
	move.l	(sp)+,a6
end;

procedure ScrollVPort; xassembler;
asm
	move.l	a6,-(sp)
	move.l	8(sp),a0
	move.l	GfxBase,a6
	jsr		-$24C(a6)
	move.l	(sp)+,a6
end;

function UCopperListInit; xassembler;
asm
	move.l	a6,-(sp)
	lea		8(sp),a6
	move.w	(a6)+,d0
	move.l	(a6)+,a0
	move.l	GfxBase,a6
	jsr		-$252(a6)
	move.l	d0,$E(sp)
	move.l	(sp)+,a6
end;

procedure FreeGBuffers; xassembler;
asm
	move.l	a6,-(sp)
	moveq	#0,d0
	lea		8(sp),a6
	move.b	(a6)+,d0
	addq.l	#1,a6
	move.l	(a6)+,a1
	move.l	(a6)+,a0
	move.l	GfxBase,a6
	jsr		-$258(a6)
	move.l	(sp)+,a6
end;

function BltBitMapRastPort; xassembler;
asm
	movem.l	d3-d6/a6,-(sp)
	lea		$18(sp),a6
	move.b	(a6)+,d6
	addq.l	#1,a6
	move.w	(a6)+,d5
	move.w	(a6)+,d4
	move.w	(a6)+,d3
	move.w	(a6)+,d2
	move.l	(a6)+,a1
	move.w	(a6)+,d1
	move.w	(a6)+,d0
	move.l	(a6)+,a0
	move.l	GfxBase,a6
	jsr		-$25E(a6)
	tst.l	d0
	sne		d0
	neg.b	d0
	move.b	d0,$2E(sp)
	movem.l	(sp)+,d3-d6/a6
end;

function OrRegionRegion; xassembler;
asm
	move.l	a6,-(sp)
	lea		8(sp),a6
	move.l	(a6)+,a1
	move.l	(a6)+,a0
	move.l	GfxBase,a6
	jsr		-$264(a6)
	tst.l	d0
	sne		d0
	neg.b	d0
	move.b	d0,$10(sp)
	move.l	(sp)+,a6
end;

function XorRegionRegion; xassembler;
asm
	move.l	a6,-(sp)
	lea		8(sp),a6
	move.l	(a6)+,a1
	move.l	(a6)+,a0
	move.l	GfxBase,a6
	jsr		-$26A(a6)
	tst.l	d0
	sne		d0
	neg.b	d0
	move.b	d0,$10(sp)
	move.l	(sp)+,a6
end;

function AndRegionRegion; xassembler;
asm
	move.l	a6,-(sp)
	lea		8(sp),a6
	move.l	(a6)+,a1
	move.l	(a6)+,a0
	move.l	GfxBase,a6
	jsr		-$270(a6)
	tst.l	d0
	sne		d0
	neg.b	d0
	move.b	d0,$10(sp)
	move.l	(sp)+,a6
end;

procedure SetRGB4CM; xassembler;
asm
	movem.l	d3/a6,-(sp)
	lea		$C(sp),a6
	move.b	(a6)+,d3
	addq.l	#1,a6
	move.b	(a6)+,d2
	addq.l	#1,a6
	move.b	(a6)+,d1
	addq.l	#1,a6
	move.w	(a6)+,d0
	move.l	(a6)+,a0
	move.l	GfxBase,a6
	jsr		-$276(a6)
	movem.l	(sp)+,d3/a6
end;

procedure BltMaskBitMapRastPort; xassembler;
asm
	movem.l	d3-d6/a2/a6,-(sp)
	lea		$1C(sp),a6
	move.l	(a6)+,a2
	move.b	(a6)+,d6
	addq.l	#1,a6
	move.w	(a6)+,d5
	move.w	(a6)+,d4
	move.w	(a6)+,d3
	move.w	(a6)+,d2
	move.l	(a6)+,a1
	move.w	(a6)+,d1
	move.w	(a6)+,d0
	move.l	(a6)+,a0
	move.l	GfxBase,a6
	jsr		-$27C(a6)
	movem.l	(sp)+,d3-d6/a2/a6
end;

function AttemptLockLayerRom; xassembler;
asm
	movem.l	a5-a6,-(sp)
	move.l	$C(sp),a5
	move.l	GfxBase,a6
	jsr		-$28E(a6)
	tst.l	d0
	sne		d0
	neg.b	d0
	move.b	d0,$10(sp)
	movem.l	(sp)+,a5-a6
end;

function GfxNew; xassembler;
asm
	move.l	a6,-(sp)
	move.l	8(sp),d0
	move.l	GfxBase,a6
	jsr		-$294(a6)
	move.l	d0,$C(sp)
	move.l	(sp)+,a6
end;

procedure GfxFree; xassembler;
asm
	move.l	a6,-(sp)
	move.l	8(sp),a0
	move.l	GfxBase,a6
	jsr		-$29A(a6)
	move.l	(sp)+,a6
end;

procedure GfxAssociate; xassembler;
asm
	move.l	a6,-(sp)
	lea		8(sp),a6
	move.l	(a6)+,a1
	move.l	(a6)+,a0
	move.l	GfxBase,a6
	jsr		-$2A0(a6)
	move.l	(sp)+,a6
end;

procedure BitMapScale; xassembler;
asm
	move.l	a6,-(sp)
	move.l	8(sp),a0
	move.l	GfxBase,a6
	jsr		-$2A6(a6)
	move.l	(sp)+,a6
end;

function ScalerDiv; xassembler;
asm
	move.l	a6,-(sp)
	lea		8(sp),a6
	move.w	(a6)+,d2
	move.w	(a6)+,d1
	move.w	(a6)+,d0
	move.l	GfxBase,a6
	jsr		-$2AC(a6)
	move.w	d0,$E(sp)
	move.l	(sp)+,a6
end;

procedure TextExtent; xassembler;
asm
	movem.l	a2/a6,-(sp)
	lea		$C(sp),a6
	move.l	(a6)+,a2
	move.w	(a6)+,d0
	move.l	(a6)+,a0
	move.l	(a6)+,a1
	move.l	GfxBase,a6
	jsr		-$2B2(a6)
	movem.l	(sp)+,a2/a6
end;

function TextFit; xassembler;
asm
	movem.l	d3/a2-a3/a6,-(sp)
	lea		$14(sp),a6
	move.w	(a6)+,d3
	move.w	(a6)+,d2
	move.w	(a6)+,d1
	move.l	(a6)+,a3
	move.l	(a6)+,a2
	move.w	(a6)+,d0
	move.l	(a6)+,a0
	move.l	(a6)+,a1
	move.l	GfxBase,a6
	jsr		-$2B8(a6)
	move.l	d0,$2C(sp)
	movem.l	(sp)+,d3/a2-a3/a6
end;

function GfxLookUp; xassembler;
asm
	move.l	a6,-(sp)
	move.l	8(sp),a0
	move.l	GfxBase,a6
	jsr		-$2BE(a6)
	move.l	d0,$C(sp)
	move.l	(sp)+,a6
end;

function VideoControl; xassembler;
asm
	move.l	a6,-(sp)
	lea		8(sp),a6
	move.l	(a6)+,a1
	move.l	(a6)+,a0
	move.l	GfxBase,a6
	jsr		-$2C4(a6)
	move.l	d0,$10(sp)
	move.l	(sp)+,a6
end;

function OpenMonitor; xassembler;
asm
	move.l	a6,-(sp)
	movem.l	8(sp),d0/a1
	move.l	GfxBase,a6
	jsr		-$2CA(a6)
	move.l	d0,$10(sp)
	move.l	(sp)+,a6
end;

function CloseMonitor; xassembler;
asm
	move.l	a6,-(sp)
	move.l	8(sp),a0
	move.l	GfxBase,a6
	jsr		-$2D0(a6)
	move.l	d0,$C(sp)
	move.l	(sp)+,a6
end;

function FindDisplayInfo; xassembler;
asm
	move.l	a6,-(sp)
	move.l	8(sp),d0
	move.l	GfxBase,a6
	jsr		-$2D6(a6)
	move.l	d0,$C(sp)
	move.l	(sp)+,a6
end;

function NextDisplayInfo; xassembler;
asm
	move.l	a6,-(sp)
	move.l	8(sp),d0
	move.l	GfxBase,a6
	jsr		-$2DC(a6)
	move.l	d0,$C(sp)
	move.l	(sp)+,a6
end;

function GetDisplayInfoData; xassembler;
asm
	move.l	a6,-(sp)
	lea		8(sp),a6
	move.l	(a6)+,d2
	move.l	(a6)+,d1
	move.l	(a6)+,d0
	move.l	(a6)+,a1
	move.l	(a6)+,a0
	move.l	GfxBase,a6
	jsr		-$2F4(a6)
	move.l	d0,$1C(sp)
	move.l	(sp)+,a6
end;

procedure FontExtent; xassembler;
asm
	move.l	a6,-(sp)
	lea		8(sp),a6
	move.l	(a6)+,a1
	move.l	(a6)+,a0
	move.l	GfxBase,a6
	jsr		-$2FA(a6)
	move.l	(sp)+,a6
end;

function ReadPixelLine8; xassembler;
asm
	movem.l	a2/a6,-(sp)
	lea		$C(sp),a6
	move.l	(a6)+,a1
	move.l	(a6)+,a2
	move.w	(a6)+,d2
	move.w	(a6)+,d1
	move.w	(a6)+,d0
	move.l	(a6)+,a0
	move.l	GfxBase,a6
	jsr		-$300(a6)
	move.l	d0,$1E(sp)
	movem.l	(sp)+,a2/a6
end;

function WritePixelLine8; xassembler;
asm
	movem.l	a2/a6,-(sp)
	lea		$C(sp),a6
	move.l	(a6)+,a1
	move.l	(a6)+,a2
	move.w	(a6)+,d2
	move.w	(a6)+,d1
	move.w	(a6)+,d0
	move.l	(a6)+,a0
	move.l	GfxBase,a6
	jsr		-$306(a6)
	move.l	d0,$1E(sp)
	movem.l	(sp)+,a2/a6
end;

function ReadPixelArray8; xassembler;
asm
	movem.l	d3/a2/a6,-(sp)
	lea		$10(sp),a6
	move.l	(a6)+,a1
	move.l	(a6)+,a2
	move.w	(a6)+,d3
	move.w	(a6)+,d2
	move.w	(a6)+,d1
	move.w	(a6)+,d0
	move.l	(a6)+,a0
	move.l	GfxBase,a6
	jsr		-$30C(a6)
	move.l	d0,$24(sp)
	movem.l	(sp)+,d3/a2/a6
end;

function WritePixelArray8; xassembler;
asm
	movem.l	d3/a2/a6,-(sp)
	lea		$10(sp),a6
	move.l	(a6)+,a1
	move.l	(a6)+,a2
	move.w	(a6)+,d3
	move.w	(a6)+,d2
	move.w	(a6)+,d1
	move.w	(a6)+,d0
	move.l	(a6)+,a0
	move.l	GfxBase,a6
	jsr		-$312(a6)
	move.l	d0,$24(sp)
	movem.l	(sp)+,d3/a2/a6
end;

function GetVPModeID; xassembler;
asm
	move.l	a6,-(sp)
	move.l	8(sp),a0
	move.l	GfxBase,a6
	jsr		-$318(a6)
	move.l	d0,$C(sp)
	move.l	(sp)+,a6
end;

function ModeNotAvailable; xassembler;
asm
	move.l	a6,-(sp)
	move.l	8(sp),d0
	move.l	GfxBase,a6
	jsr		-$31E(a6)
	move.l	d0,$C(sp)
	move.l	(sp)+,a6
end;

function WeighTAMatch; xassembler;
asm
	movem.l	a2/a6,-(sp)
	lea		$C(sp),a6
	move.l	(a6)+,a2
	move.l	(a6)+,a1
	move.l	(a6)+,a0
	move.l	GfxBase,a6
	jsr		-$324(a6)
	move.w	d0,$18(sp)
	movem.l	(sp)+,a2/a6
end;

procedure EraseRect; xassembler;
asm
	movem.l	d3/a6,-(sp)
	lea		$C(sp),a6
	move.w	(a6)+,d3
	move.w	(a6)+,d2
	move.w	(a6)+,d1
	move.w	(a6)+,d0
	move.l	(a6)+,a1
	move.l	GfxBase,a6
	jsr		-$32A(a6)
	movem.l	(sp)+,d3/a6
end;

function ExtendFont; xassembler;
asm
	move.l	a6,-(sp)
	lea		8(sp),a6
	move.l	(a6)+,a1
	move.l	(a6)+,a0
	move.l	GfxBase,a6
	jsr		-$330(a6)
	move.l	d0,$10(sp)
	move.l	(sp)+,a6
end;

procedure StripFont; xassembler;
asm
	move.l	a6,-(sp)
	move.l	8(sp),a0
	move.l	GfxBase,a6
	jsr		-$336(a6)
	move.l	(sp)+,a6
end;

end.
