unit Intuition;

INTERFACE
uses Exec, Graphics, Input, Keymap, Timer, Utility;


type
	ClassID = pbyte;
	Msg = ^tMsg;
	Object = long;
	pIClass = ^tIClass;
	tIClass = record
		cl_Dispatcher: tHook;
		cl_Reserved: long;
		cl_Super: pIClass;
		cl_ID: pbyte;
		cl_InstOffset: word;
		cl_InstSize: word;
		cl_UserData: long;
		cl_SubclassCount: long;
		cl_ObjectCount: long;
		cl_Flags: long;
		end;

	Class = tIClass;
	pBorder = ^tBorder;
	tBorder = record
		LeftEdge: integer;
		TopEdge: integer;
		FrontPen: byte;
		BackPen: byte;
		DrawMode: byte;
		Count: shortint;
		XY: pinteger;
		NextBorder: pBorder;
		end;

	pMenu = ^tMenu;
	pMenuItem = ^tMenuItem;
	tMenu = record
		NextMenu: pMenu;
		LeftEdge: integer;
		TopEdge: integer;
		Width: integer;
		Height: integer;
		Flags: word;
		MenuName: pshortint;
		FirstItem: pMenuItem;
		JazzX: integer;
		JazzY: integer;
		BeatX: integer;
		BeatY: integer;
		end;

	pScreen = ^tScreen;
	pWindow = ^tWindow;
	pGadget = ^tGadget;
	tScreen = record
		NextScreen: pScreen;
		FirstWindow: pWindow;
		LeftEdge: integer;
		TopEdge: integer;
		Width: integer;
		Height: integer;
		MouseY: integer;
		MouseX: integer;
		Flags: word;
		Title: pbyte;
		DefaultTitle: pbyte;
		BarHeight: shortint;
		BarVBorder: shortint;
		BarHBorder: shortint;
		MenuVBorder: shortint;
		MenuHBorder: shortint;
		WBorTop: shortint;
		WBorLeft: shortint;
		WBorRight: shortint;
		WBorBottom: shortint;
		Font: pTextAttr;
		ViewPort: tViewPort;
		RastPort: tRastPort;
		BitMap: tBitMap;
		LayerInfo: tLayer_Info;
		FirstGadget: pGadget;
		DetailPen: byte;
		BlockPen: byte;
		SaveColor0: word;
		BarLayer: pLayer;
		ExtData: pbyte;
		UserData: pbyte;
		end;

	pIBox = ^tIBox;
	pDrawInfo = ^tDrawInfo;
	pimpFrameBox = ^timpFrameBox;
	timpFrameBox = record
		MethodID: long;
		imp_ContentsBox: pIBox;
		imp_FrameBox: pIBox;
		imp_DrInfo: pDrawInfo;
		imp_FrameFlags: long;
		end;

	pGadgetInfo = ^tGadgetInfo;
	pgpGoInactive = ^tgpGoInactive;
	tgpGoInactive = record
		MethodID: long;
		gpgi_GInfo: pGadgetInfo;
		gpgi_Abort: long;
		end;

	pPropInfo = ^tPropInfo;
	tPropInfo = record
		Flags: word;
		HorizPot: word;
		VertPot: word;
		HorizBody: word;
		VertBody: word;
		CWidth: word;
		CHeight: word;
		HPotRes: word;
		VPotRes: word;
		LeftBorder: word;
		TopBorder: word;
		end;

	popGet = ^topGet;
	topGet = record
		MethodID: long;
		opg_AttrID: long;
		opg_Storage: plong;
		end;

	pRemember = ^tRemember;
	tRemember = record
		NextRemember: pRemember;
		RememberSize: long;
		Memory: pbyte;
		end;

	pimpErase = ^timpErase;
	timpErase = record
		MethodID: long;
		imp_RPort: pRastPort;
		imp_Offset: record
		X: integer;
		Y: integer;
		end;
		imp_Dimensions: record
		Width: integer;
		Height: integer;
		end;
		end;

	popMember = ^topMember;
	topMember = record
		MethodID: long;
		opam_Object: plong;
		end;

	pgpHitTest = ^tgpHitTest;
	tgpHitTest = record
		MethodID: long;
		gpht_GInfo: pGadgetInfo;
		gpht_Mouse: record
		X: integer;
		Y: integer;
		end;
		end;

	pgpRender = ^tgpRender;
	tgpRender = record
		MethodID: long;
		gpr_GInfo: pGadgetInfo;
		gpr_RPort: pRastPort;
		gpr_Redraw: longint;
		end;

	pStringExtend = ^tStringExtend;
	pStringInfo = ^tStringInfo;
	tStringInfo = record
		Buffer: pbyte;
		UndoBuffer: pbyte;
		BufferPos: integer;
		MaxChars: integer;
		DispPos: integer;
		UndoPos: integer;
		NumChars: integer;
		DispCount: integer;
		CLeft: integer;
		CTop: integer;
		Extension: pStringExtend;
		LongInt_: longint;
		AltKeyMap: pKeyMap;
		end;

	pimpDraw = ^timpDraw;
	timpDraw = record
		MethodID: long;
		imp_RPort: pRastPort;
		imp_Offset: record
		X: integer;
		Y: integer;
		end;
		imp_State: long;
		imp_DrInfo: pDrawInfo;
		imp_Dimensions: record
		Width: integer;
		Height: integer;
		end;
		end;

	popSet = ^topSet;
	topSet = record
		MethodID: long;
		ops_AttrList: pTagItem;
		ops_GInfo: pGadgetInfo;
		end;

	pIntuiMessage = ^tIntuiMessage;
	tIntuiMessage = record
		ExecMessage: tMessage;
		Class: long;
		Code: word;
		Qualifier: word;
		IAddress: pointer;
		MouseX: integer;
		MouseY: integer;
		Seconds: long;
		Micros: long;
		IDCMPWindow: pWindow;
		SpecialLink: pIntuiMessage;
		end;

	pImage = ^tImage;
	pNewWindow = ^tNewWindow;
	tNewWindow = record
		LeftEdge: integer;
		TopEdge: integer;
		Width: integer;
		Height: integer;
		DetailPen: shortint;
		BlockPen: shortint;
		IDCMPFlags: long;
		Flags: long;
		FirstGadget: pGadget;
		CheckMark: pImage;
		Title: pbyte;
		Screen: pScreen;
		BitMap: pBitMap;
		MinWidth: integer;
		MinHeight: integer;
		MaxWidth: word;
		MaxHeight: word;
		Type_: word;
		end;

	pExtNewWindow = ^tExtNewWindow;
	tExtNewWindow = record
		LeftEdge: integer;
		TopEdge: integer;
		Width: integer;
		Height: integer;
		DetailPen: shortint;
		BlockPen: shortint;
		IDCMPFlags: long;
		Flags: long;
		FirstGadget: pGadget;
		CheckMark: pImage;
		Title: pbyte;
		Screen: pScreen;
		BitMap: pBitMap;
		MinWidth: integer;
		MinHeight: integer;
		MaxWidth: word;
		MaxHeight: word;
		Type_: word;
		Extension: pTagItem;
		end;

	pimpHitTest = ^timpHitTest;
	timpHitTest = record
		MethodID: long;
		imp_Point: record
		X: integer;
		Y: integer;
		end;
		imp_Dimensions: record
		Width: integer;
		Height: integer;
		end;
		end;

	popUpdate = ^topUpdate;
	topUpdate = record
		MethodID: long;
		opu_AttrList: pTagItem;
		opu_GInfo: pGadgetInfo;
		opu_Flags: long;
		end;

	pRequester = ^tRequester;
	tWindow = record
		NextWindow: pWindow;
		LeftEdge: integer;
		TopEdge: integer;
		Width: integer;
		Height: integer;
		MouseY: integer;
		MouseX: integer;
		MinWidth: integer;
		MinHeight: integer;
		MaxWidth: word;
		MaxHeight: word;
		Flags: long;
		MenuStrip: pMenu;
		Title: pbyte;
		FirstRequest: pRequester;
		DMRequest: pRequester;
		ReqCount: integer;
		WScreen: pScreen;
		RPort: pRastPort;
		BorderLeft: shortint;
		BorderTop: shortint;
		BorderRight: shortint;
		BorderBottom: shortint;
		BorderRPort: pRastPort;
		FirstGadget: pGadget;
		Parent: pWindow;
		Descendant: pWindow;
		Pointer: pword;
		PtrHeight: shortint;
		PtrWidth: shortint;
		XOffset: shortint;
		YOffset: shortint;
		IDCMPFlags: long;
		UserPort: pMsgPort;
		WindowPort: pMsgPort;
		MessageKey: pIntuiMessage;
		DetailPen: byte;
		BlockPen: byte;
		CheckMark: pImage;
		ScreenTitle: pbyte;
		GZZMouseX: integer;
		GZZMouseY: integer;
		GZZWidth: integer;
		GZZHeight: integer;
		ExtData: pbyte;
		UserData: pshortint;
		WLayer: pLayer;
		IFont: pTextFont;
		MoreFlags: long;
		end;

	pPreferences = ^tPreferences;
	tPreferences = record
		FontHeight: shortint;
		PrinterPort: byte;
		BaudRate: word;
		KeyRptSpeed: ttimeval;
		KeyRptDelay: ttimeval;
		DoubleClick: ttimeval;
		PointerMatrix: array [0..35] of word;
		XOffset: shortint;
		YOffset: shortint;
		color17: word;
		color18: word;
		color19: word;
		PointerTicks: word;
		color0: word;
		color1: word;
		color2: word;
		color3: word;
		ViewXOffset: shortint;
		ViewYOffset: shortint;
		ViewInitX: integer;
		ViewInitY: integer;
		EnableCLI: word;
		PrinterType: word;
		PrinterFilename: array [0..29] of byte;
		PrintPitch: word;
		PrintQuality: word;
		PrintSpacing: word;
		PrintLeftMargin: word;
		PrintRightMargin: word;
		PrintImage: word;
		PrintAspect: word;
		PrintShade: word;
		PrintThreshold: integer;
		PaperSize: word;
		PaperLength: word;
		PaperType: word;
		SerRWBits: byte;
		SerStopBuf: byte;
		SerParShk: byte;
		LaceWB: byte;
		WorkName: array [0..29] of byte;
		RowSizeChange: shortint;
		ColumnSizeChange: shortint;
		PrintFlags: word;
		PrintMaxWidth: word;
		PrintMaxHeight: word;
		PrintDensity: byte;
		PrintXOffset: byte;
		wb_Width: word;
		wb_Height: word;
		wb_Depth: byte;
		ext_size: byte;
		end;

	pIntuitionBase = ^tIntuitionBase;
	tIntuitionBase = record
		LibNode: tLibrary;
		ViewLord: tView;
		ActiveWindow: pWindow;
		ActiveScreen: pScreen;
		FirstScreen: pScreen;
		Flags: long;
		MouseY: integer;
		MouseX: integer;
		Seconds: long;
		Micros: long;
		end;

	pIntuiText = ^tIntuiText;
	tIntuiText = record
		FrontPen: byte;
		BackPen: byte;
		DrawMode: byte;
		LeftEdge: integer;
		TopEdge: integer;
		ITextFont: pTextAttr;
		IText: pbyte;
		NextText: pIntuiText;
		end;

	tStringExtend = record
		Font: pTextFont;
		Pens: array [0..1] of byte;
		ActivePens: array [0..1] of byte;
		InitialModes: long;
		EditHook: pHook;
		WorkBuffer: pbyte;
		Reserved: array [0..3] of long;
		end;

	pgpInput = ^tgpInput;
	tgpInput = record
		MethodID: long;
		gpi_GInfo: pGadgetInfo;
		gpi_IEvent: pInputEvent;
		gpi_Termination: plongint;
		gpi_Mouse: record
		X: integer;
		Y: integer;
		end;
		end;

	pEasyStruct = ^tEasyStruct;
	tEasyStruct = record
		es_StructSize: long;
		es_Flags: long;
		es_Title: pbyte;
		es_TextFormat: pbyte;
		es_GadgetFormat: pbyte;
		end;

	tIBox = record
		Left: integer;
		Top: integer;
		Width: integer;
		Height: integer;
		end;

	pPGX = ^tPGX;
	tPGX = record
		pgx_Container: tIBox;
		pgx_NewKnob: tIBox;
		end;

	tRequester = record
		OlderRequest: pRequester;
		LeftEdge: integer;
		TopEdge: integer;
		Width: integer;
		Height: integer;
		RelLeft: integer;
		RelTop: integer;
		ReqGadget: pGadget;
		ReqBorder: pBorder;
		ReqText: pIntuiText;
		Flags: word;
		BackFill: byte;
		ReqLayer: pLayer;
		ReqPad1: array [0..31] of byte;
		ImageBMap: pBitMap;
		RWindow: pWindow;
		ReqImage: pImage;
		ReqPad2: array [0..31] of byte;
		end;

	pSGWork = ^tSGWork;
	tSGWork = record
		Gadget: pGadget;
		StringInfo: pStringInfo;
		WorkBuffer: pbyte;
		PrevBuffer: pbyte;
		Modes: long;
		IEvent: pInputEvent;
		Code: word;
		BufferPos: integer;
		NumChars: integer;
		Actions: long;
		LongInt_: longint;
		GadgetInfo: pGadgetInfo;
		EditOp: word;
		end;

	popAddTail = ^topAddTail;
	topAddTail = record
		MethodID: long;
		opat_List: pList;
		end;

	tGadgetInfo = record
		gi_Screen: pScreen;
		gi_Window: pWindow;
		gi_Requester: pRequester;
		gi_RastPort: pRastPort;
		gi_Layer: pLayer;
		gi_Domain: tIBox;
		gi_Pens: record
		DetailPen: byte;
		BlockPen: byte;
		end;
		gi_DrInfo: pDrawInfo;
		gi_Reserved: array [0..5] of long;
		end;

	tImage = record
		LeftEdge: integer;
		TopEdge: integer;
		Width: integer;
		Height: integer;
		Depth: integer;
		ImageData: pword;
		PlanePick: byte;
		PlaneOnOff: byte;
		NextImage: pImage;
		end;

	pPubScreenNode = ^tPubScreenNode;
	tPubScreenNode = record
		psn_Node: tNode;
		psn_Screen: pScreen;
		psn_Flags: word;
		psn_Size: integer;
		psn_VisitorCount: integer;
		psn_SigTask: pTask;
		psn_SigBit: byte;
		end;

	tGadget = record
		NextGadget: pGadget;
		LeftEdge: integer;
		TopEdge: integer;
		Width: integer;
		Height: integer;
		Flags: word;
		Activation: word;
		GadgetType: word;
		GadgetRender: pointer;
		SelectRender: pointer;
		GadgetText: pIntuiText;
		MutualExclude: longint;
		SpecialInfo: pointer;
		GadgetID: word;
		UserData: pointer;
		end;

	pBoolInfo = ^tBoolInfo;
	tBoolInfo = record
		Flags: word;
		Mask: pword;
		Reserved: long;
		end;

	tDrawInfo = record
		dri_Version: word;
		dri_NumPens: word;
		dri_Pens: pword;
		dri_Font: pTextFont;
		dri_Depth: word;
		dri_Resolution: record
		X: word;
		Y: word;
		end;
		dri_Flags: long;
		dri_Reserved: array [0..6] of long;
		end;

	p_Object = ^t_Object;
	t_Object = record
		o_Node: tMinNode;
		o_Class: pIClass;
		end;

	tMsg = record
		MethodID: long;
		end;

	tMenuItem = record
		NextItem: pMenuItem;
		LeftEdge: integer;
		TopEdge: integer;
		Width: integer;
		Height: integer;
		Flags: word;
		MutualExclude: longint;
		ItemFill: pointer;
		SelectFill: pointer;
		Command: shortint;
		SubItem: pMenuItem;
		NextSelect: word;
		end;

	pNewScreen = ^tNewScreen;
	tNewScreen = record
		LeftEdge: integer;
		TopEdge: integer;
		Width: integer;
		Height: integer;
		Depth: integer;
		DetailPen: byte;
		BlockPen: byte;
		ViewModes: word;
		Type_: word;
		Font: pTextAttr;
		DefaultTitle: pbyte;
		Gadgets: pGadget;
		CustomBitMap: pBitMap;
		end;

	pColorSpec = ^tColorSpec;
	tColorSpec = record
		ColorIndex: integer;
		Red: word;
		Green: word;
		Blue: word;
		end;

	pExtNewScreen = ^tExtNewScreen;
	tExtNewScreen = record
		LeftEdge: integer;
		TopEdge: integer;
		Width: integer;
		Height: integer;
		Depth: integer;
		DetailPen: byte;
		BlockPen: byte;
		ViewModes: word;
		Type_: word;
		Font: pTextAttr;
		DefaultTitle: pbyte;
		Gadgets: pGadget;
		CustomBitMap: pBitMap;
		Extension: pTagItem;
		end;



const
	SYSREQUEST = $4000;
	IDCMP_VANILLAKEY = $200000;
	SHOWTITLE = $10;
	GTYP_GTYPEMASK = 7;
	BEEPING = $20;
	TOPAZ_SIXTY = 9;
	FANFOLD = 0;
	ALTRIGHT = $20;
	IM_DRAWFRAME = $206;
	CHECKIT = 1;
	IDCMP_WBENCHMESSAGE = $20000;
	WFLG_WINDOWACTIVE = $2000;
	SSTOP_BITS = $F0;
	FRAMEICLASS = 'frameiclass';
	SYSISIZE_LOWRES = 1;
	GFLG_GADGIMAGE = 4;
	STRINGA_ReplaceMode = $8003200D;
	SDEPTHIMAGE = 5;
	DOWNBACKGADGET = 1;
	HIGHLIGHTTEXTPEN = 8;
	SBUF_4096 = 3;
	PGA_NewLook = $8003100A;
	PREDRAWN = 2;
	AUTOKNOB = 1;
	FREEVERT = 4;
	OKOK = 1;
	WBENCHCLOSE = 2;
	SPARITY_SPACE = 4;
	AUTOBACKPEN = 1;
	STRINGA_NoFilterMode = $8003200F;
	IA_Data = $80020007;
	KNOBVMIN = 4;
	WA_IDCMP = $8000006A;
	OM_REMOVE = $106;
	GMR_MEACTIVE = 0;
	GMR_REUSE = 4;
	SYSISIZE_HIRES = 2;
	SELECTUP = $E8;
	GA_Image = $8003000A;
	PGA_Freedom = $80031001;
	IM_ERASE = $204;
	DRAGGADGET = 4;
	SA_BitMap = $8000002E;
	OKIMATE_20 = 9;
	GREY_SCALE2 = $1000;
	STRINGA_MaxChars = $80032001;
	STRINGA_EditHook = $8003200B;
	GTYP_CUSTOMGADGET = 5;
	POPPUBSCREEN = 2;
	N_TRACTOR = $20;
	SHSHAKE_NONE = 2;
	ICCLASS = 'icclass';
	STRINGA_LongVal = $80032011;
	SA_Obsolete1 = $80000035;
	SBUFSIZE_BITS = $F;
	OM_REMMEMBER = $10A;
	STRINGA_EditModes = $8003200C;
	EVENTMAX = $A;
	CUSTOMBITMAP = $40;
	SHSHAKE_BITS = $F;
	GACT_LONGINT = $800;
	IDCMP_INACTIVEWINDOW = $80000;
	OSERR_NOCHIPS = 2;
	SHADE_GREYSCALE = 1;
	CORRECT_BLUE = 4;
	AUTOITEXTFONT = 0;
	BUTTONGCLASS = 'buttongclass';
	GA_RelHeight = $80030008;
	PGA_Top = $80031009;
	STDSCREENHEIGHT = $FFFFFFFF;
	KEYCODE_LESS = $38;
	GA_Disabled = $8003000E;
	GADGETCOUNT = 8;
	REQOFFWINDOW = $1000;
	CUSTOMSCREEN = $F;
	SA_PubName = $8000002F;
	US_LEGAL = $10;
	GA_UserData = $80030011;
	POINTREL = 1;
	GACT_ENDGADGET = 4;
	SA_BlockPen = $80000027;
	DIAB_630 = 4;
	MENUDOWN = $69;
	GA_DrawInfo = $80030021;
	PGA_VertBody = $80031006;
	UPIMAGE = $B;
	MXIMAGE = $F;
	HIGHBOX = $80;
	USEREQIMAGE = $20;
	GACT_LEFTBORDER = $20;
	ICA_Dummy = $80040000;
	IA_Mode = $80020012;
	FILLPEN = 5;
	LOWCOMMWIDTH = $10;
	OM_NOTIFY = $107;
	ICA_MAP = $80040002;
	IDCMP_RAWKEY = $400;
	SA_DetailPen = $80000026;
	W_TRACTOR = $30;
	EURO_A0 = $50;
	MENUNULL = $FFFF;
	MENUTOGGLED = $4000;
	IDCMP_REQSET = $80;
	WA_BlockPen = $80000069;
	WA_NoCareRefresh = $80000087;
	SCREENHIRES = $200;
	OSERR_PUBNOTUNIQUE = 5;
	EURO_A1 = $60;
	ALTLEFT = $10;
	GA_SpecialInfo = $80030012;
	PGA_Total = $80031007;
	PGA_Visible = $80031008;
	EO_ENTER = 5;
	WFLG_REFRESHBITS = $C0;
	WA_PubScreenName = $80000078;
	PARALLEL_PRINTER = 0;
	BAUD_110 = 0;
	US_LETTER = 0;
	EURO_A2 = $70;
	GA_Left = $80030001;
	GA_LeftBorder = $80030019;
	STRINGA_ExitHelp = $80032013;
	SA_PubSig = $80000030;
	SA_Behind = $80000037;
	SCREEN_DRAG = $4000;
	BAUD_300 = 1;
	EURO_A3 = $80;
	PGA_HorizBody = $80031004;
	STRINGA_Buffer = $80032002;
	ICSPECIAL_CODE = $80040003;
	DEPTHIMAGE = 0;
	RESCOUNT = 2;
	EO_DELBACKWARD = 2;
	ITEMTEXT = 2;
	GFLG_LABELITEXT = 0;
	KNOBHIT = $100;
	IDCMP_DELTAMOVE = $100000;
	WA_DetailPen = $80000068;
	WA_SizeBRight = $8000008E;
	DRIF_NEWLOOK = 1;
	EURO_A4 = $90;
	KEYCODE_GREATER = $39;
	IMAGECLASS = 'imageclass';
	GA_RelRight = $80030002;
	LORIENT_HORIZ = 1;
	IA_Left = $80020001;
	IA_APattern = $80020010;
	CLOSEIMAGE = 3;
	EO_MOVECURSOR = 4;
	GFLG_GADGHCOMP = 0;
	GACT_STRINGRIGHT = $400;
	IDCMP_INTUITICKS = $400000;
	WA_DepthGadget = $80000083;
	EURO_A5 = $A0;
	INTEGER_SCALING = $100;
	STRINGA_UndoBuffer = $80032003;
	GFLG_GADGHNONE = 3;
	MENUCANCEL = 2;
	WA_CloseGadget = $80000084;
	MOUSE_ACCEL = $8000;
	EURO_A6 = $B0;
	AUTOFRONTPEN = 0;
	GA_RelWidth = $80030006;
	GA_Height = $80030007;
	STRINGA_BufferPos = $80032005;
	STRINGA_DispPos = $80032006;
	EO_RESET = 6;
	SGA_END = 2;
	MIDRAWN = $100;
	GFLG_LABELMASK = $3000;
	OKABORT = 4;
	WFLG_SUPER_BITMAP = $80;
	BAUD_19200 = 6;
	EURO_A7 = $C0;
	AUTOTOPEDGE = 3;
	PGA_VertPot = $80031005;
	STRINGA_ActivePens = $8003200A;
	IDCMP_MENUVERIFY = $2000;
	WFLG_RMBTRAP = $10000;
	LACEWB = 1;
	EURO_A8 = $D0;
	AMIGARIGHT = $80;
	IA_Height = $80020004;
	IA_LineWidth = $80020008;
	SGM_REPLACE = 1;
	GACT_IMMEDIATE = 2;
	GACT_BOOLEXTEND = $2000;
	MAXBODY = $FFFF;
	SHADE_COLOR = 2;
	CORRECT_RGB_MASK = 7;
	CHECKWIDTH = $13;
	GA_SysGadget = $8003001D;
	PGA_Dummy = $80031000;
	STRINGA_Pens = $80032009;
	EO_REPLACECHAR = 7;
	COMMSEQ = 4;
	NOISYREQ = 4;
	STRINGA_Font = $80032008;
	ICM_Dummy = $401;
	IA_EdgesOnly = $80020017;
	SGM_NOFILTER = 4;
	SGM_EXITHELP = $80;
	WA_MinHeight = $80000073;
	GA_Border = $8003000B;
	GA_SysGType = $8003001E;
	GM_GOACTIVE = 2;
	IM_HITFRAME = $208;
	GACT_FOLLOWMOUSE = 8;
	IDCMP_LONELYMESSAGE = $80000000;
	OSERR_UNKNOWNMODE = 6;
	ASPECT_HORIZ = 0;
	PIXEL_DIMENSIONS = $40;
	GA_Selected = $80030013;
	STRINGA_TextVal = $80032012;
	RIGHTIMAGE = $C;
	ISDRAWN = $1000;
	GTYP_GADGET0002 = 2;
	WFLG_SIZEGADGET = 1;
	WA_MaxHeight = $80000075;
	CBM_MPS1000 = 3;
	GA_Immediate = $80030015;
	PGA_HorizPot = $80031003;
	LORIENT_NONE = 0;
	IDCMP_SIZEVERIFY = 1;
	MENUWAITING = 3;
	WA_WBenchWindow = $8000008B;
	SCREENQUIET = $100;
	SA_Left = $80000021;
	SA_PubTask = $80000031;
	WA_Flags = $8000006B;
	SA_ErrorCode = $8000002A;
	GA_Top = $80030003;
	GA_SelectRender = $8003000C;
	GA_TopBorder = $8003001A;
	IA_Pens = $8002000E;
	IM_FRAMEBOX = $207;
	WA_SuperBitMap = $80000071;
	WA_SizeGadget = $80000081;
	OSCAN_VIDEO = 4;
	GROUPGCLASS = 'groupgclass';
	GA_RightBorder = $80030018;
	LAYOUTA_Spacing = $80038002;
	IA_Font = $80020013;
	WFLG_HASZOOM = $20000000;
	WA_MenuHelp = $80000092;
	IMAGE_NEGATIVE = 1;
	GA_ToggleSelect = $8003001C;
	IA_Top = $80020002;
	GTYP_BOOLGADGET = 1;
	WA_Left = $80000064;
	SA_Height = $80000024;
	PSNF_PRIVATE = 1;
	CORRECT_RED = 1;
	FLOYD_DITHERING = $400;
	MIDDLEDOWN = $6A;
	MODELCLASS = 'modelclass';
	OPUF_INTERIM = 1;
	GA_Width = $80030005;
	STRINGA_WorkBuffer = $80032004;
	IDS_BUSY = 3;
	SIZEGADGET = 2;
	HIGHIMAGE = 0;
	WFLG_SIZEBBOTTOM = $20;
	SA_Depth = $80000025;
	EPSON_JX_80 = 8;
	CURSORUP = $4C;
	IA_Recessed = $80020015;
	WBENCHOPEN = 1;
	IA_Width = $80020003;
	MENUHOT = 1;
	WA_PubScreen = $80000079;
	FILLTEXTPEN = 6;
	IA_DoubleEmboss = $80020016;
	GFLG_GADGHIGHBITS = 3;
	WFLG_NW_EXTENDED = $40000;
	WA_Height = $80000067;
	WA_SizeBBottom = $8000008F;
	SBUF_16000 = 5;
	GA_RelBottom = $80030004;
	GA_Highlight = $8003000D;
	GA_RelVerify = $80030016;
	GA_Next = $80030020;
	SGM_FIXEDFIELD = 2;
	GFLG_RELHEIGHT = $40;
	GACT_STRINGLEFT = 0;
	IDCMP_REQCLEAR = $1000;
	IDCMP_CHANGEWINDOW = $2000000;
	WA_Gadgets = $8000006C;
	WA_Checkmark = $8000006D;
	WA_MinWidth = $80000072;
	NS_EXTENDED = $1000;
	HP_LASERJET = $B;
	SPARITY_MARK = 3;
	GFLG_DISABLED = $100;
	GACT_ACTIVEGADGET = $4000;
	TOPAZ_EIGHTY = 8;
	IM_DRAW = $202;
	IDCMP_GADGETUP = $40;
	WA_MaxWidth = $80000074;
	WA_InnerHeight = $80000077;
	WA_Backdrop = $80000085;
	SA_Pens = $8000003A;
	OM_ADDTAIL = $105;
	PGA_Borderless = $80031002;
	SA_Font = $8000002B;
	DIAB_ADV_D25 = 5;
	SPARITY_EVEN = 1;
	AMIGALEFT = $40;
	STRINGA_Dummy = $80032000;
	LAYOUTA_LayoutObj = $80038001;
	IDCMP_REFRESHWINDOW = 4;
	WFLG_BORDERLESS = $800;
	SA_Top = $80000022;
	HALFTONE_DITHERING = $200;
	DIMENSIONS_MASK = $F0;
	ICTARGET_IDCMP = $FFFFFFFF;
	SINGLE = $80;
	SBUF_512 = 0;
	SPARITY_NONE = 0;
	GA_Text = $80030009;
	SGA_USE = 1;
	HIGHFLAGS = $C0;
	TEXTPEN = 2;
	DEADEND_ALERT = $80000000;
	DMODECOUNT = 2;
	NOREQBACKFILL = $40;
	SA_Width = $80000023;
	SPARITY_BITS = $F0;
	AUTONEXTTEXT = 0;
	GA_Dummy = $80030000;
	LORIENT_VERT = 2;
	ICA_TARGET = $80040001;
	LEFTIMAGE = $A;
	EO_UNDO = $B;
	WA_Top = $80000065;
	QUME_LP_20 = $A;
	ABSOLUTE_DIMENSIONS = $20;
	FRAMEF_SPECIFY = 1;
	EO_SPECIAL = $D;
	SGH_KEY = 1;
	GTYP_SUPFRONT = $50;
	IDCMP_REQVERIFY = $800;
	WFLG_VISITOR = $8000000;
	SA_Title = $80000028;
	OSCAN_STANDARD = 2;
	ANTI_ALIAS = $800;
	IA_Dummy = $80020000;
	WFLG_SIZEBRIGHT = $10;
	OSERR_NOCHIPMEM = 4;
	CUSTOM_NAME = 0;
	SHSHAKE_XON = 0;
	LAYOUTA_Dummy = $80038000;
	IM_MOVE = $205;
	MENUTOGGLE = 8;
	GACT_ALTKEYMAP = $1000;
	IDCMP_DISKINSERTED = $8000;
	WA_Width = $80000066;
	WA_WindowName = $8000007B;
	SA_FullPalette = $8000003B;
	POINTERSIZE = $24;
	CURSORRIGHT = $4E;
	GA_BottomBorder = $8003001B;
	SG_DEFAULTMAXCHARS = $80;
	IDCMP_MOUSEMOVE = $10;
	WFLG_NOCAREREFRESH = $20000;
	WFLG_ZOOMED = $10000000;
	SELECTDOWN = $68;
	GFLG_GADGHBOX = 1;
	GTYP_WUPFRONT = $40;
	IDCMP_MENUPICK = $100;
	WA_Title = $8000006E;
	WA_Activate = $80000089;
	BACKGROUNDPEN = 7;
	ICM_SETLOOP = $402;
	EO_NOOP = 1;
	WA_InnerWidth = $80000076;
	SA_Type = $8000002D;
	SHSHAKE_RTS = 1;
	DITHERING_MASK = $600;
	IA_BGPen = $80020006;
	PROPNEWLOOK = $10;
	IDCMP_MENUHELP = $1000000;
	WFLG_REPORTMOUSE = $200;
	WA_ScreenTitle = $8000006F;
	DETAILPEN = 0;
	SA_Quiet = $80000038;
	ASPECT_VERT = 1;
	HP_LASERJET_PLUS = $C;
	BOUNDED_DIMENSIONS = $10;
	NOITEM = $3F;
	GFLG_TABCYCLE = $200;
	GTYP_PROPGADGET = 3;
	STDSCREENWIDTH = $FFFFFFFF;
	SGM_LONGINT = $40;
	GTYP_GADGETTYPE = $FC00;
	LW_RESERVED = 1;
	SPARITY_ODD = 2;
	IDS_INACTIVENORMAL = 5;
	GFLG_SELECTED = $80;
	WA_GimmeZeroZero = $80000091;
	NSTAG_EXT_VPMODE = $80000001;
	PROPGCLASS = 'propgclass';
	GREDRAW_TOGGLE = 0;
	IA_FGPen = $80020005;
	SUPFRONTGADGET = 5;
	DRI_VERSION = 1;
	SA_Dummy = $80000020;
	SA_SysFont = $8000002C;
	LETTER = $100;
	GA_GZZGadget = $8003000F;
	GM_Dummy = $FFFFFFFF;
	GREDRAW_UPDATE = 2;
	IA_Outline = $80020014;
	GACT_TOPBORDER = $40;
	SA_Colors = $80000029;
	SREAD_BITS = $F0;
	AMIGAKEYS = $C0;
	GM_HANDLEINPUT = 3;
	DOWNIMAGE = $D;
	WA_Zoom = $8000007D;
	OSERR_NOMEM = 3;
	NOMENU = $1F;
	FILLRECTCLASS = 'fillrectclass';
	GA_IntuiText = $80030022;
	GREDRAW_REDRAW = 1;
	GMR_NOREUSE = 2;
	IDCMP_ACTIVEWINDOW = $40000;
	WA_AutoAdjust = $80000090;
	SCREENTYPE = $F;
	SA_ShowTitle = $80000036;
	SA_AutoScroll = $80000039;
	SIX_LPI = 0;
	SGM_CONTROL = $20;
	IDCMP_IDCMPUPDATE = $800000;
	WA_Dummy = $80000063;
	WA_RptQueue = $80000080;
	BAUD_MIDI = 7;
	SIZEIMAGE = 2;
	LOWRESPICK = 1;
	SGM_NOWORKB = $10;
	WFLG_SIMPLE_REFRESH = $40;
	WA_Colors = $8000007C;
	SGA_PREVACTIVE = $40;
	NUMDRIPENS = 9;
	SCREENBEHIND = $80;
	SA_Overscan = $80000034;
	DRAFT = 0;
	GA_FollowMouse = $80030017;
	IMAGE_POSITIVE = 0;
	ALPHA_P_101 = 1;
	LOWCHECKWIDTH = $D;
	ICM_CHECKLOOP = $404;
	IM_ERASEFRAME = $209;
	EO_BIGCHANGE = $A;
	SGA_NEXTACTIVE = $20;
	GACT_RELVERIFY = 1;
	GACT_TOGGLESELECT = $100;
	PROPBORDERLESS = 8;
	IDCMP_NEWPREFS = $4000;
	ELITE = $400;
	OM_Dummy = $100;
	CLF_INLIST = 1;
	IDS_INACTIVEDISABLED = 7;
	HIRESPICK = 0;
	GFLG_RELBOTTOM = 8;
	GTYP_SCRGADGET = $4000;
	GTYP_REQGADGET = $1000;
	MAXPOT = $FFFF;
	WA_SimpleRefresh = $8000008C;
	AUTOSCROLL = $4000;
	BAUD_1200 = 2;
	GA_ID = $80030010;
	IDS_NORMAL = 0;
	REQACTIVE = $2000;
	ORDERED_DITHERING = 0;
	MENUUP = $E9;
	CURSORLEFT = $4F;
	SYSIA_DrawInfo = $80020018;
	GTYP_SDRAGGING = $30;
	OKCANCEL = 2;
	WA_RMBTrap = $8000008A;
	WA_SmartRefresh = $8000008D;
	CUSTOM = $40;
	SWRITE_BITS = $F;
	KEYCODE_B = $35;
	OM_GET = $104;
	WFLG_BACKDROP = $100;
	BAUD_2400 = 3;
	WA_MouseQueue = $8000007E;
	DIAB_C_150 = 6;
	GMR_GADGETHIT = 4;
	SGH_CLICK = 2;
	SHANGHAI = 1;
	ZOOMIMAGE = 1;
	GFLG_GADGHIMAGE = 2;
	GTYP_WDRAGGING = $20;
	SHADOWPEN = 4;
	SYSISIZE_MEDRES = 0;
	WA_CustomScreen = $80000070;
	GMR_PREVACTIVE = $20;
	ICM_CLEARLOOP = $403;
	IDS_INDETERMINATE = 4;
	DEFERREFRESH = $8000;
	GTYP_SDOWNBACK = $70;
	IDCMP_DISKREMOVED = $10000;
	UPFRONTGADGET = 0;
	FILENAME_SIZE = $1E;
	BAUD_4800 = 4;
	COMMWIDTH = $1B;
	GMR_NEXTACTIVE = $10;
	SYSIA_Which = $8002000D;
	GTYP_SIZING = $10;
	WBENCHSCREEN = 1;
	OM_DISPOSE = $102;
	GM_GOINACTIVE = 4;
	IDS_DISABLED = 2;
	GFLG_LABELIMAGE = $2000;
	FREEHORIZ = 2;
	WA_Borderless = $80000088;
	SYSIA_Depth = $8002000C;
	EO_DELFORWARD = 3;
	GTYP_WDOWNBACK = $60;
	SERIAL_PRINTER = 1;
	BAUD_9600 = 5;
	AUTOLEFTEDGE = 6;
	OM_NEW = $101;
	STRINGA_FixedFieldMode = $8003200E;
	MULTIPLY_DIMENSIONS = $80;
	KEYCODE_M = $37;
	GA_Previous = $8003001F;
	CHECKED = $100;
	GFLG_RELRIGHT = $10;
	WFLG_ACTIVATE = $1000;
	WFLG_MENUSTATE = $8000;
	PICA = 0;
	CURSORDOWN = $4D;
	KEYCODE_N = $36;
	OM_SET = $103;
	GA_LabelImage = $80030023;
	SIMPLEREQ = $10;
	WA_PubScreenFallBack = $8000007A;
	RECOVERY_ALERT = 0;
	OM_ADDMEMBER = $109;
	STRINGA_Justification = $80032010;
	GFLG_RELWIDTH = $20;
	GACT_BOTTOMBORDER = $80;
	WFLG_WINDOWREFRESH = $1000000;
	BLOCKPEN = 1;
	OSCAN_TEXT = 1;
	CORRECT_GREEN = 2;
	LAYOUTA_Orientation = $80038003;
	GM_HITTEST = 0;
	GM_RENDER = 1;
	IDS_INACTIVESELECTED = 6;
	HIGHCOMP = $40;
	HIGHITEM = $2000;
	GTYP_CLOSE = $80;
	GTYP_STRGADGET = 4;
	EPSON = 7;
	ALERT_TYPE = $80000000;
	KEYCODE_Q = $10;
	SDOWNBACKGADGET = 6;
	ITEMENABLED = $10;
	HIGHNONE = $C0;
	DEFAULTMOUSEQUEUE = 5;
	PUBLICSCREEN = 2;
	MAXPUBSCREENNAME = $8B;
	EIGHT_LPI = $200;
	BROTHER_15XL = 2;
	GMR_VERIFY = 8;
	IM_HITTEST = $203;
	GTYP_GZZGADGET = $2000;
	OSERR_NOMONITOR = 1;
	FINE = $800;
	NOSUB = $1F;
	STRGCLASS = 'strgclass';
	GA_EndGadget = $80030014;
	IDCMP_GADGETDOWN = $20;
	WFLG_DEPTHGADGET = 4;
	STRINGA_AltKeyMap = $80032007;
	EO_INSERTCHAR = 8;
	GACT_STRINGCENTER = $200;
	WFLG_DRAGBAR = 2;
	WFLG_CLOSEGADGET = 8;
	SDRAGGADGET = 7;
	SGA_REDISPLAY = $10;
	GACT_BORDERSNIFF = $8000;
	WA_ReportMouse = $80000086;
	OSCAN_MAX = 3;
	CENTER_IMAGE = 8;
	MIDDLEUP = $EA;
	KEYCODE_V = $34;
	SYSIA_Size = $8002000B;
	EO_BADFORMAT = 9;
	GTYP_SYSGADGET = $8000;
	ROOTCLASS = 'rootclass';
	CUSTOMIMAGEDEPTH = $FFFFFFFF;
	MENUENABLED = 1;
	KNOBHMIN = 6;
	WFLG_GIMMEZEROZERO = $400;
	WFLG_INREQUEST = $4000;
	RI_VERSION = 1;
	SBUF_1024 = 1;
	KEYCODE_X = $32;
	FRBUTTONCLASS = 'frbuttonclass';
	IA_APatSize = $80020011;
	SGA_BEEP = 4;
	IDCMP_CLOSEWINDOW = $200;
	WFLG_OTHER_REFRESH = $C0;
	SBUF_8000 = 4;
	GFLG_LABELSTRING = $1000;
	BOOLMASK = 1;
	WFLG_WINDOWTICKED = $4000000;
	KEYCODE_Z = $31;
	GADGETCLASS = 'gadgetclass';
	CLOSEGADGET = 3;
	IGNORE_DIMENSIONS = 0;
	SYSICLASS = 'sysiclass';
	OM_UPDATE = $108;
	IDS_SELECTED = 1;
	LOWRESGADGET = 1;
	SGA_REUSE = 8;
	GACT_STRINGEXTEND = $2000;
	SHINEPEN = 3;
	SA_DClip = $80000033;
	GA_TabCycle = $80030024;
	IA_Resolution = $8002000F;
	EO_CLEAR = $C;
	SGM_NOCHANGE = 8;
	GFLG_STRINGEXTEND = $400;
	WFLG_WBENCHWINDOW = $2000000;
	WA_BackFill = $8000007F;
	WA_DragBar = $80000082;
	GACT_RIGHTBORDER = $10;
	IDCMP_MOUSEBUTTONS = 8;
	WFLG_SMART_REFRESH = 0;
	CHECKIMAGE = $E;
	IDCMP_NEWSIZE = 2;
	SA_DisplayID = $80000032;
	SHADE_BW = 0;
	SBUF_2048 = 2;
	AUTODRAWMODE = 1;
	HIRESGADGET = 0;




IMPLEMENTATION
end.
